#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <sstream>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <cstdlib>
#include <cstdio>
#include <utility>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<vector<int>> g;
vector<bool> used;
vector<int> colors;
int cnt;
vector<pair<int, int>> ans;
map<int, map<int, bool>> vis;

void dfs(int v) {
    used[v] = true;
    colors[v] = ++cnt;

    for (auto to : g[v]) {
        if (!used[to]) {
            vis[v][to] = vis[to][v] = true;
            dfs(to);
            ans.push_back({v + 1, to + 1});
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m; cin >> n >> m;
    g.resize(n);
    vector<pair<int, int>> edges;

    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        g[--u].push_back(--v), g[v].push_back(u);
        edges.push_back({u, v});
    }

    used.resize(n, false), colors.resize(n, -1);
    dfs(0);

    int fictive = n;

    for (auto &[u, v] : edges) {
        if (!vis[u][v]) {
            colors.push_back(colors[v]);
            ans.push_back({u + 1, ++fictive});
        }
    }

    cout << colors.size() << "\n";
    for (auto i : colors) cout << i << " ";
    cout << "\n";

    for (auto &[u, v] : ans) cout << u << " " << v << "\n";

    return 0;
}