#include <bits/stdc++.h>

using namespace std;

#define PI 3.141592653589	
#define endl "\n"
#define int long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x.size())
#define fr(i,a,b) for(int i = (a); i < (b); ++i)

#define vi vector<int>
#define vpi vector<pair<int, int>>

struct node{
	bool fixed;
	int cord;
	bool push;
};

const int N = 2e5 + 100;
node tree[4 * N];

void push(int u){
	if(!tree[u].push) return;
	tree[2 * u + 1].fixed = tree[u].fixed;
	tree[2 * u + 2].fixed = tree[u].fixed;
	tree[2 * u + 1].cord = tree[u].cord;
	tree[2 * u + 2].cord = tree[u].cord;
	tree[2 * u + 1].push = tree[u].push;
	tree[2 * u + 2].push = tree[u].push;
	tree[u].push = 0;	
}

void build(int u, int l, int r){
	if(l + 1 == r){
		tree[u].fixed = 1;
		tree[u].cord = 1;
		tree[u].push = 0;
		return;
	}
	int m = (l + r) / 2;
	build(2 * u + 1, l, m);
	build(2 * u + 2, m, r);
	tree[u].push = 0;
}

node get(int u, int l, int r, int i){
	if(l + 1 == r) return tree[u];
	push(u);
	int m = (l + r) / 2;
	if(i < m) return get(2 * u + 1, l, m, i);
	else return get(2 * u + 2, m, r, i);
}

void change(int u, int l, int r, int ql, int qr, node v){
	if(qr <= l || r <= ql) return;
	if(ql <= l && r <= qr) {
		tree[u] = v;
		return;
	}
	push(u);
	int m = (l + r) / 2;
	change(2 * u + 1, l, m, ql, qr, v);
	change(2 * u + 2, m, r, ql, qr, v);
}

pair<int, int> point(node x, int i){
	pair<int, int> r;	
	if(x.fixed) r.first = i + 1 - x.cord, r.second = x.cord;
	else r.first = x.cord, r.second = i + 1 - x.cord;
	return r;
}

void solve(){
	int n, q;
	cin >> n;
	build(0, 0, n);
//	node x = get(0, 0, n, 0);
//	if(x.fixed) cout << 1 + 1 - x.cord << ' ' << x.cord;
//	else cout << x.cord << ' ' << 1 + 1 - x.cord;
	cin >> q;
	while(q--){
		int t;
		cin >> t;
		if(t == 2){
			int i; cin >> i;
				node x = get(0, 0, n, i - 1);
				pair<int, int> v = point(x, i);
				cout << v.first << " " << v.second - 1;
				cout << endl;
		} else {
			int l, r;
			cin >> l >> r;
			if(l == r) continue;
			node le = get(0, 0, n, l - 1), re = get(0, 0, n, r - 1);
			pair<int, int> f = point(le, l), s = point(re, r);
			//cout << f.first << ' ' << f.second << endl << endl;
			node x;
			if(f.second == s.second){
				x.fixed = 0;
				x.cord = f.first;
				x.push = 1;
			} else {
				x.fixed = 1;
				x.cord = f.second;
				x.push = 1;
			}
			change(0, 0, n, l - 1, r, x);
		}
	}
}

signed main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0); cin.tie(0);
    int t;
    t = 1;
    //cin >> t;
    while(t--) {solve();}
    return 0;
}
