import java.awt.*;
import java.io.*;
import java.util.Arrays;
import java.util.HashSet;
import java.util.StringTokenizer;

public class Main {

    public static void main(String[] args) throws Throwable {
        taskA();
        flush();
    }

    public static void taskA() {
        int n = nextInt();
        int[] l = new int[n];
        for (int i = 0; i < n; i++) l[i] = nextInt();
        HashSet<Point> set = new HashSet<>();
        boolean[] b = new boolean[n];
        deepA(set, b, l, n, 0, 0);
        println(set.size());
    }

    private static void deepA(HashSet<Point> set, boolean[] b, int[] l, int n, int x, int y) {
        for (int i = 0; i < n; i++) {
            if (!b[i]) {
                boolean[] nb = Arrays.copyOf(b, n);
                nb[i] = true;
                for (int j = 0; j <= l[i]; j++) {
                    set.add(new Point(x + j, y));
                    set.add(new Point(x, y + j));
                }
                deepA(set, nb, l, n,x + l[i], y);
                deepA(set, nb, l, n, x, y + l[i]);
            }
        }
    }

    private static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    private static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    private static StringTokenizer tokenizer;

    public static void flush() {
        try {
            writer.flush();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void print(String string) {
        try {
            writer.write(string);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void print(byte x) {
        print(x + "");
    }

    public static void print(short x) {
        print(x + "");
    }

    public static void print(int x) {
        print(x + "");
    }

    public static void print(long x) {
        print(x + "");
    }

    public static void print(double x) {
        print(x + "");
    }

    public static void print(float x) {
        print(x + "");
    }

    public static void print(char x) {
        print(x + "");
    }

    public static void print(boolean x) {
        print(x + "");
    }

    public static void print(Object o) {
        print(String.valueOf(o));
    }

    public static void println() {
        try {
            writer.newLine();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void println(String string) {
        try {
            writer.write(string);
            writer.newLine();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void println(byte x) {
        println(x + "");
    }

    public static void println(short x) {
        println(x + "");
    }

    public static void println(int x) {
        println(x + "");
    }

    public static void println(long x) {
        println(x + "");
    }

    public static void println(double x) {
        println(x + "");
    }

    public static void println(float x) {
        println(x + "");
    }

    public static void println(char x) {
        println(x + "");
    }

    public static void println(boolean x) {
        println(x + "");
    }

    public static void println(Object o) {
        println(String.valueOf(o));
    }

    public static String next() {
        try {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) tokenizer = new StringTokenizer(reader.readLine());
            return tokenizer.nextToken();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static String nextLine() {
        try {
            tokenizer = null;
            return reader.readLine();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static byte nextByte() {
        return Byte.parseByte(next());
    }

    public static short nextShort() {
        return Short.parseShort(next());
    }

    public static int nextInt() {
        return Integer.parseInt(next());
    }

    public static long nextLong() {
        return Long.parseLong(next());
    }

    public static double nextDouble() {
        return Double.parseDouble(next());
    }

    public static float nextFloat() {
        return Float.parseFloat(next());
    }

    public static char nextChar() {
        return next().charAt(0);
    }

    public static boolean nextBoolean() {
        return Boolean.parseBoolean(next());
    }

}