#pragma comment(linker, "/stack:200000000")
#pragma GCC optimize("O3")
#pragma GCC target ("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set =
tree<T, null_type, less<T>, rb_tree_tag, 
tree_order_statistics_node_update>;

typedef long long ll;

struct pt {
    double x, y;
};

vector<pt> a;
double l;

bool cmp(pt a, pt b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool cw(pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}

bool ccw(pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}

void convex_hull() {
    if (a.size() == 1)
        return;
    sort(a.begin(), a.end(), &cmp);
    pt p1 = a[0], p2 = a.back();
    vector<pt> up, down;
    up.push_back(p1);
    down.push_back(p1);
    for (int i = 1; i < (int)a.size(); i++) {
        if (i == a.size() - 1 || cw(p1, a[i], p2)) {
            while (up.size() >= 2 && !cw(up[up.size()-2], up[up.size()-1], a[i]))
                up.pop_back();
            up.push_back(a[i]);
        }
        if (i == a.size() - 1 || ccw(p1, a[i], p2)) {
            while(down.size() >= 2 && !ccw(down[down.size()-2], down[down.size()-1], a[i]))
                down.pop_back();
            down.push_back(a[i]);
        }
    }
    a.clear();
    for (int i = 0; i < (int)up.size(); i++)
        a.push_back(up[i]);
    for (int i = down.size() - 2; i > 0; i--)
        a.push_back(down[i]);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);     
	int n;
	cin >> n >> l;
	for (int i = 0; i < n; i++) {
		double x, y;
		cin >> x >> y;
		a.pb({x-l, y});
		a.pb({x+l, y});
		a.pb({x, y-l});
		a.pb({x, y+l});
	} 
	cout << "\n";
	convex_hull();
	int n1=a.size();
	double p = 0;
	for (int i = 0; i < n1-1; ++i)
    	p += sqrt((a[i].x - a[i+1].x)*(a[i].x - a[i+1].x) + (a[i].y - a[i+1].y)*(a[i].y - a[i+1].y));
	p += sqrt((a[0].x - a[n1-1].x)*(a[0].x - a[n1-1].x) + (a[0].y - a[n1-1].y)*(a[0].y - a[n1-1].y));
	cout<<fixed<<setprecision(10)<<p;
	//for (pt x : a) cout << x.x << ' ' << x.y << "\n";
	return 0;
}   