#include <bits/stdc++.h>
using namespace std;

#define ios ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

///pragms:

//#pragma GCC optimize("Ofast")

//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")

using ull = unsigned long long;
using ll = long long;
using ld = long double;
//using ui = unsigned int;

/*const int MAX_MEM = 1e8;
int mpos = 0;
char mem[MAX_MEM];
inline void * operator new ( size_t n ) {
    char *res = mem + mpos;
    mpos += n;
    assert(mpos <= MAX_MEM);
    return (void *)res;
}
inline void operator delete ( void * ) { }*/

const ld eps = 1e-9;

const ld inf = 1e18;

const ld pi = acos(-1);

struct point
{
    ld x;
    ld y;
    point() : x(-inf), y(-inf) {};
    point(ld x1, ld y1) : x(x1), y(y1) {};
    inline bool same(point u)
    {
        return abs(u.x - x) < eps && abs(u.y - y) < eps;
    }
    inline ld dist(point u)
    {
        return sqrt(abs((u.x - x)*(u.x - x) + (u.y - y)*(u.y - y)));
    }
};

struct line
{
    ld a, b, c;
    line(point A, point B) : a(A.y - B.y), b(B.x - A.x), c(A.x*B.y - B.x*A.y) {};
    inline bool same(line L)
    {
        return abs(L.a * b - a*L.b) < eps && abs(c*L.b - L.c*b) < eps;
    }
    inline point intersect(line L)
    {
        if(abs(L.a * b - a*L.b) < eps && abs(c*L.b - L.c*b) < eps)
        {
            ld num = 12.379;
            return point(num, (-c - a*num) / b);
        }
        else if(abs(a*L.b - L.a * b) < eps)
        {
            return point(inf, inf);
        }
        else
            return point((b * L.c - c * L.b) / (a * L.b - L.a * b), (L.a * c - a * L.c) / (a * L.b - L.a * b));
    }
};

struct segment
{
    point a;
    point b;
    segment(point a1, point b1) : a(a1), b(b1) {};
    inline bool is_in(point p)
    {
        return p.same(a) || p.same(b) || abs((b.y - p.y) * (p.x - a.x) - (p.y - a.y)*(b.x - p.x)) < eps &&
                                                        ((p.x > min(a.x, b.x) || abs(p.x - min(a.x, b.x)) < eps)
                                                        && (p.x < max(a.x, b.x) || abs(p.x - max(a.x, b.x)) < eps)
                                                        && (p.y > min(a.y, b.y) || abs(p.y - min(a.y, b.y)) < eps) &&
                                                        (p.y < max(a.y, b.y) || abs(p.y - max(a.y, b.y)) < eps));
    }
    inline bool is_intersect_segment(segment u)
    {
        point p = line(a, b).intersect(line(u.a, u.b));
        return abs(p.x - inf) > eps && abs(p.y - inf) > eps && (*this).is_in(p) && u.is_in(p);
    }
    point intersect_segment(segment u)
    {
        point p = line(a, b).intersect(line(u.a, u.b));
        return p;
    }
};

struct ray
{
    point a;
    point b;
    ray(point a1, point b1) : a(a1), b(b1) {};
    inline bool is_in(point p)
    {
        return p.same(a) || p.same(b) || abs((b.y - p.y) * (p.x - a.x) - (p.y - a.y)*(b.x - p.x)) < eps
        && (((b.x - a.x)*(p.x - a.x) > 0 || abs((b.x - a.x)*(p.x - a.x)) < eps) && ((b.y - a.y) * (p.y - a.y) > 0 || abs((b.y - a.y) * (p.y - a.y)) < eps));
    }
    inline bool is_intersect_segment(segment u)
    {
        point p = line(a, b).intersect(line(u.a, u.b));
        return abs(p.x - inf) > eps && abs(p.y - inf) > eps && u.is_in(p) && (*this).is_in(p);
    }
    inline bool is_intersect_ray(ray u)
    {
        if(line(a, b).same(line(u.a, u.b)))
        {
            return u.is_in(a) || (*this).is_in(u.a);
        }
        point p = line(a, b).intersect(line(u.a, u.b));
        return u.a.same(a) || abs(p.x - inf) > eps && abs(p.y - inf) > eps && u.is_in(p) && (*this).is_in(p);
    }
    inline ld kos(ray u)
    {
        return (b.x - a.x) * (u.b.y - u.a.y) - (u.b.x - u.a.x) * (b.y - a.y);
    }
};

inline bool __point_comp(point &a, point &b)
{
    return abs(a.x - b.x) < eps ? a.y < b.y : a.x < b.x;
}

/*inline ld polar_angle(const point &x)
{
    ld a = atan2(x.y, x.x);
    if(a < 0)
        a += 2 * pi;
    return a;
}

inline ld angle(const point &a, const point &b)
{
    ld phi = abs(polar_angle(a) - polar_angle(b));
    if(phi > pi)
        phi = 2 * pi - phi;
    return phi;
}*/

struct polygon
{
    vector<point> v;
    polygon() : v(vector<point>(0)) {};
    polygon(vector<point> &a) : v(a) {};
    void convex_hull_sort()
    {
        if(v.size() == 1)
            return;
        vector<point> up;
        vector<point> down;
        sort(v.begin(), v.end(), __point_comp);
        point p1 = v[0], p2 = v.back();
        down.emplace_back(p1);
        up.emplace_back(p1);
        for(int i = 1; i < v.size(); ++i)
        {
            if(i == v.size() - 1 || ray(v[i], p1).kos(ray(v[i], p2)) > 0)
            {
                while(up.size() > 1 && ray(up.back(), v[i]).kos(ray(up.back(), up[up.size() - 2])) >= 0)
                {
                    up.pop_back();
                }
                up.emplace_back(v[i]);
            }
            if(i == v.size() - 1 || ray(v[i], p1).kos(ray(v[i], p2)) < 0)
            {
                while(down.size() > 1 && ray(down.back(), down[down.size() - 2]).kos(ray(down.back(), v[i])) >= 0)
                {
                    down.pop_back();
                }
                down.emplace_back(v[i]);
            }
        }
        v.clear();
        for(auto &pp : down)
            v.emplace_back(pp);
        for(int i = up.size() - 2; i > 0; --i)
            v.emplace_back(up[i]);
    }
    inline ld getp()
    {
        ld p = 0;
        int n = v.size();
        for(int i = 0; i < n; ++i)
        {
            p += v[i].dist(v[(i + 1) % n]);
        }
        return p;
    }
    inline ld gets()
    {
        ld s = 0;
        point o(0, 0);
        int n = v.size();
        for(int i = 0; i < n; ++i)
        {
            s += ray(o, v[i]).kos(ray(o, v[(i + 1) % n]));
        }
        return abs(s / 2.);
    }
    inline bool is_in_randomized(point ps) ///O(n)
    {
        point pt(2836284.2832920, -9297289.7342689);
        ray w(ps, pt);
        int cnt = 0;
        int n = v.size();
        for(int i = 0; i < n; ++i)
        {
            if(segment(v[i], v[(i + 1) % n]).is_in(ps) || ps.same(v[i]))
                return 1;
            cnt += w.is_intersect_segment(segment(v[i], v[(i + 1) % n]));
        }
        return cnt % 2;
    }
    inline bool is_in_convex(point p) ///O(log(n))
    {
        int n = v.size();
        if(!n)
            return 0;
        if(n == 1)
            return v[0].same(p);
        if(n == 2)
            return segment(v[0], v[1]).is_in(p);
        if(p.same(v[0]))
            return 1;
        ld a = (p.y - v[0].y) / (p.x - v[0].x);
        ld b = (v[n - 1].y - v[0].y) / (v[n - 1].x - v[0].x);
        if(a > b)
            return 0;
        b = (v[1].y - v[0].y) / (v[1].x - v[0].x);
        if(a < b)
            return 0;
        int l = 1, r = n - 1;
        while(r - l > 1)
        {
            int m = (l + r) >> 1;
            b = (v[m].y - v[0].y) / (v[m].x - v[0].x);
            if(b > a)
                r = m;
            else
                l = m;
        }
        vector<point> __triangle(3);
        __triangle[0] = v[0];
        __triangle[1] = v[l];
        __triangle[2] = v[r];
        return polygon(__triangle).is_in_randomized(p);
    }
};

void input(point &p)
{
    cin >> p.x >> p.y;
}

void output(point p)
{
    cout << p.x << ' ' << p.y << '\n';
}

signed main()
{
    ios;
    int n;
    ld l;
    cin >> n >> l;
    vector<point> a(n);
    for(int i = 0; i < n; ++i)
    {
        input(a[i]);
    }
    polygon w(a);
    w.convex_hull_sort();
    ld p = w.getp();
    int k = w.v.size();
    for(int i = 0; i < w.v.size(); ++i)
    {
        ld ax = a[(i - 1 + k) % k].x - a[i].x;
        ld ay = a[(i - 1 + k) % k].y - a[i].y;
        ld bx = a[(i + 1) % k].x - a[i].x;
        ld by = a[(i + 1) % k].y - a[i].y;
        ld cosa = (ax * bx + ay * by) / (w.v[(i - 1 + k) % k].dist(w.v[i]) * w.v[i].dist(w.v[(i + k + 1) % k]));
        p += l * sqrt(2 + 2 * cosa);
    }
    cout << fixed << setprecision(16) << p;
    return 0;
}
