/*
	Code written by Talant I.D.
*/
 
#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
 
#define precision(n) fixed << setprecision(n)
#define pb push_back
#define ub upper_bound
#define lb lower_bound
#define mp make_pair
#define eps (double)1e-15
#define PI 2*acos(0.0)
#define endl "\n"
#define sz(v) int((v).size())
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define do_not_disturb ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define OK cout << "OK" << endl;
 
inline bool isvowel(char ch){
	ch = tolower(ch);
	return (ch == 'a' || ch == 'e' || ch == 'i' || ch == 'o' || ch == 'u');
}
 
inline bool isprime(int n){
	if(n < 2 || (n%2 == 0 && n != 2)) return false;
	for(int i = 3; i*i <= n; i++)
		if(n%i == 0) return false;
	return true;
}

class Union{
    private:
        vector <int> saizu, link;
    public:
        Union(int n){
            saizu.assign(n, 1); link.resize(n); 
            iota(all(link), 0);
        }
        int find(int n){
            if(link[n] == n) return n;
            return link[n] = find(link[n]);
        }
        int same(int a, int b){
            return find(a) == find(b);
        }
        void unite(int a, int b){
            if(same(a, b)) return;
            
            a = find(a); b = find(b);
            if(saizu[a] < saizu[b]) swap(a, b);
            
            saizu[a] += saizu[b];
            link[b] = a;
        }
        int getsize(int a){
            return saizu[find(a)];
        }
};

const int mod = 1e9+7;

ll mode(ll a){
    a %= mod;
    if(a < 0) a += mod;
    return a;
}

ll subt(ll a, ll b){
    return mode(mode(a)-mode(b));
}

ll add(ll a, ll b){
    return mode(mode(a)+mode(b));
}

ll mult(ll a, ll b){
    return mode(mode(a)*mode(b));
}

ll binpow(ll a, ll b){
    ll res = 1;
    while(b){
        if(b&1) res = mult(res, a);
        a = mult(a, a);
        b >>= 1;
    }
    return res;
}

#define pdd pair <double, double> 

const int N = 1e5+7;
int n;
double len;
vector <pdd> all, hull;

int orientation(pdd a, pdd b, pdd c){
    b.first -= a.first; b.second -= a.second;
    c.first -= a.first; c.second -= a.second;
    
    double val = b.first*c.second-b.second*c.first;
    if(val > 0) return 1;
    return -1;
}

void convex_hull(){
    vector <pdd> hull1, hull2;
    
    for(int i = 0; i < sz(all); i++){
        hull1.pb(all[i]);
        while(sz(hull1) >= 3){
            int val = orientation(hull1[sz(hull1)-3], hull1[sz(hull1)-2], hull1[sz(hull1)-1]);
            if(val == 1){
                auto to = hull1.back();
                hull1.pop_back(); hull1.pop_back();
                hull1.pb(to);
            }
            else break;
        }
    }
    for(int i = sz(all)-1; i >= 0; i--){
        hull2.pb(all[i]);
        while(sz(hull2) >= 3){
            int val = orientation(hull2[sz(hull2)-3], hull2[sz(hull2)-2], hull2[sz(hull2)-1]);
            if(val == 1){
                auto to = hull2.back();
                hull2.pop_back(); hull2.pop_back();
                hull2.pb(to);
            }
            else break;
        }
    }
    for(auto to : hull1) hull.pb(to);
    for(int i = 1; i < sz(hull2)-1; i++){
        hull.pb(hull2[i]);
    }
}

int main(){
    do_not_disturb
    
    cin >> n >> len;
    set <pdd> st;
    for(int i = 0; i < n; i++){
        int x, y;
        cin >> x >> y;
        st.insert(mp(x, y));
        st.insert(mp(x+len, y));
        st.insert(mp(x, y+len));
        st.insert(mp(x, y-len));
        st.insert(mp(x-len, y));
    }
    
    for(auto to : st) all.pb(to);
    
    convex_hull();
    
    hull.pb(hull[0]);
    
    double ans = 0;
    for(int i = 0; i < sz(hull)-1; i++){
        ans += hypot(hull[i].first-hull[i+1].first, hull[i].second-hull[i+1].second);
    }
    
    cout << precision(10) << ans;
    
	return 0;
}
