#include <iostream>
#include <functional>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <set>
#define fi first
#define se second
#define mp make_pair
#define sz(a) (int) a.size()
#define len(s) (int) s.length()
#define vi vector<int>
#define pi pair<int, int>
#define fori(a, b) for (int i = a; i < b; ++i)
#define forj(a, b) for (int j = a; j < b; ++j)
#define fork(a, b) for (int k = a; k < b; ++k)
typedef long long ll;
using namespace std;
#define MULTITASK ELT

int cross(const pi& x, const pi& y) {
  return x.first * y.second - x.second * y.first;
}

pi sub(const pi& x, const pi& y) {
  return {x.first - y.first, x.second - y.second};
}

void solve() {
  int n; ll l; cin >> n >> l;
  vector<pi> points(n * 4);
  for (int i = 0; i < n; i++)
  {
    int x, y; cin >> x >> y; 
    points[4 * i + 0] = {x + l, y};
    points[4 * i + 1] = {x - l, y};
    points[4 * i + 2] = {x, y + l};
    points[4 * i + 3] = {x, y - l};
  }
  sort(points.begin(), points.end());
  pi first = points[0];
  n = 4 * n;
  pi last = points[n - 1];
  vector<pi> lower{first}, upper{first};
  for (int i = 0; i < n; i++)
  {
    if (cross(sub(points[i], first), sub(last, first)) > 0) {
      lower.push_back(points[i]);
    } else {
      upper.push_back(points[i]);
    }
  }
  lower.push_back(last);
  upper.push_back(last);

  int m = size(lower);
  int before = 0, cur = 1, after = 2;
  vector<pi> result{lower[before]};
  while(after != m) {
    if (cross(sub(lower[cur], lower[before]), sub(lower[after], lower[cur])) > 0) {
      result.push_back(lower[cur]);
      before = cur;
    }
    cur++;
    after++;
  }
  result.push_back(last);
  
  reverse(upper.begin(), upper.end());

  m = size(upper);
  before = 0; 
  cur = 1; 
  after = 2;
  while(after != m) {
    if (cross(sub(upper[cur], upper[before]), sub(upper[after], upper[cur])) > 0) {
      result.push_back(upper[cur]);
      before = cur;
    }
    cur++;
    after++;
  }

  double per = 0;
  for (int i = 0; i < result.size() - 1; i++)
  {
    pi vector_ = sub(result[i], result[i + 1]);
    per += hypot(vector_.first, vector_.second);
  }
  pi vector_ = sub(result[result.size() - 1], result[0]);
  per += hypot(vector_.first, vector_.second);

  cout << per << "\n";
}


int main() {
#if ELT
  freopen("input.txt", "r", stdin);
#endif
  cout.precision(15);
#if MULTITASK
  int q; cin >> q; while (q--) { solve(); }
#else
  solve();
#endif

  return 0;
}
