#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e5 + 100, INF = 1e18;

struct Point {
    int x, y;

    Point(int x, int y) : x(x), y(y) {}

    Point() {}

    long double len() {
        return sqrt(x * x + y * y);
    }

    int operator*(Point b) {
        return x * b.x + y * b.y;
    }

    int operator%(Point b) {
        return x * b.y - b.x * y;
    }

    Point operator-(Point b) {
        return Point(x - b.x, y - b.y);
    }

    Point operator+(Point b) {
        return Point(x + b.x, y + b.y);
    }

};

int n, l;
pair < int, int > a[N];
vector < Point > b;

bool cmp(Point f, Point s) {
    return (f - b[0]) % (s - b[0]) < 0;
}

void solve() {
    cin >> n >> l;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        b.push_back(Point(a[i].first + l, a[i].second));
        b.push_back(Point(a[i].first, a[i].second + l));
        b.push_back(Point(a[i].first - l, a[i].second));
        b.push_back(Point(a[i].first, a[i].second - l));
    }
    Point p(INF, INF);
    int pos;
    for (int i = 0; i < b.size(); i++) {
        if (b[i].y < p.y || (b[i].y == p.y && b[i].x < p.x)) {
            pos = i;
            p = b[i];
        }
    }
    swap(b[0], b[pos]);
    sort(b.begin() + 1, b.end(), cmp);
    b.push_back(b[0]);
    vector < Point > st;
    for (int i = 0; i < b.size(); i++) {
        while (st.size() > 1 && (st.back() - st[st.size() - 2]) % (b[i] - st[st.size() - 2]) >= 0) st.pop_back();
        st.push_back(b[i]);
    }
    long double ans = 0;
    for (int i = 0; i < st.size() - 1; i++) {
        ans += (st[i + 1] - st[i]).len();
    }
    cout << fixed << setprecision(20) << ans;
}
