#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 2e5 + 100, A = 1e6 + 100, INF = 1e18;

struct segment_tree {
    int t[4 * N], mod[4 * N];

    segment_tree() {
        for (int i = 0; i < 4 * N; i++) {
            mod[i] = -1;
        }
    }

    void push(int v, int l, int r) {
        if (mod[v] != -1) {
            t[v] = mod[v];
            if (l != r) {
                mod[v * 2] = mod[v];
                mod[v * 2 + 1] = mod[v];
            }
            mod[v] = -1;
        }
    }

    void update(int v, int l, int r, int tl, int tr, int val) {
        push(v, l, r);
        if (l >= tl && r <= tr) {
            mod[v] = val;
            push(v, l, r);
            return;
        }
        if (l > tr || r < tl) return;
        int m = (r + l) / 2;
        update(v * 2, l, m, tl, tr, val);
        update(v * 2 + 1, m + 1, r, tl, tr, val);
    }

    int get(int v, int l, int r, int pos) {
        push(v, l, r);
        if (l == r) {
            return t[v];
        } else {
            int m = (r + l) / 2;
            if (pos <= m) return get(v * 2, l, m, pos);
            else return get(v * 2 + 1, m + 1, r, pos);
        }
    }
};

int n, q, fen[N];
pair < int, int > a[N];
map < pair < int, int >, int > ma;
segment_tree tree;

void update(int pos, int val) {
    for (int i = pos; i < N; i |= i + 1) {
        fen[i] += val;
    }
}

int get(int pos) {
    int res = 0;
    for (int i = pos; i >= 0; i = (i & (i + 1)) - 1) {
        res += fen[i];
    }
    return res;
}

pair < int, int > f(int pos) {
    int e = tree.get(1, 0, N - 1, pos);
    if (get(pos) % 2 == 1) {
        return {a[e].first, a[e].second + pos - e};
    } else {
        return {a[e].first + pos - e, a[e].second};
    }
}

void solve() {
    cin >> n >> q;
    a[0] = {1, 0};
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r;
            cin >> l >> r;
            l--, r--;
            if (l == r) continue;
            if (!ma.count({l, r})) {
                a[l] = f(l);
                ma[{l, r}] = tree.get(1, 0, N - 1, l);
                update(l + 1, 1);
                update(r + 1, -1);
                tree.update(1, 0, N - 1, l + 1, r, l);
            } else {
                int last = ma[{l, r}];
                ma.erase({l, r});
                update(l + 1, -1);
                update(r + 1, 1);
                tree.update(1, 0, N - 1, l + 1, r, last);
            }
        } else {
            int pos;
            cin >> pos;
            pos--;
            pair < int, int > pr = f(pos);
            cout << pr.first << " " << pr.second << '\n';
        }
    }
}
