#include <iostream>
#include <algorithm>
#include <sstream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <deque>
#include <unordered_set>

using namespace std;
#define li long long int
#define rep(n) for(li i = 0; i < n; i++)
#define pub push_back
#define sortv(myobject) sort(myobject.begin(), myobject.end(), myobject)
#define print(some) cout << some << endl

template<class Container>
bool contains(const Container& o, const typename Container::value_type d)
{
	return std::any_of(o.begin(), o.end(), [&d](const auto& value){ return value == d; });
}

template<class Container>
vector<li> indexes_of(const Container& j, const typename Container::value_type& o)
{
	vector<li> res;

	rep(j.size())
	{
		if (j[i] == o)
			res.push_back(i);
	}
	return res;
}

/**
 * @return str [start : end)
 */
string cut(const string& str, li start, li end)
{
	return str.substr(start, end - start);
}

bool isPrime(int num)
{
	if (num <= 1)
		return false;
	else if (num == 2)
		return true;
	else if (num % 2 == 0)
		return false;
	else
	{
		bool prime = true;
		int divisor = 3;
		double num_d = static_cast<double>(num);
		int upperLimit = static_cast<int>(sqrt(num_d) + 1);

		while (divisor <= upperLimit)
		{
			if (num % divisor == 0)
				prime = false;
			divisor += 2;
		}
		return prime;
	}
}
int gcd(int a, int b)
{
	for (;;)
	{
		if (a == 0) return b;
		b %= a;
		if (b == 0) return a;
		a %= b;
	}
}

int lcm(int a, int b)
{
	int temp = gcd(a, b);

	return temp ? (a / temp * b) : 0;
}
int scm(int a, int b, int c)
{
	return lcm(lcm(a, b), c);
}
// End of std head



int main() {
	std::ios::sync_with_stdio(false);

	li n;
	cin >> n;

	vector<li> forces(n);
	// forces.reserve(n);

	for (size_t i = 0; i < n; ++i) {
		std::cin >> forces[i];
	}

	std::unordered_set<li> possible_sums_set { 0 };

	for(auto& new_force : forces) {
		auto local_copy = possible_sums_set;

		for(auto& prev_sum : local_copy) {
			possible_sums_set.insert(prev_sum + new_force);
		}
	}

	std::vector<li> possible_sums(possible_sums_set.begin(), possible_sums_set.end());
	std:sort(possible_sums.begin(), possible_sums.end());

	std::vector<li> dists;
	dists.reserve(possible_sums.size() - 1);

	for (size_t i = 1; i < possible_sums.size(); ++i) {
		dists.push_back(possible_sums[i] - possible_sums[i - 1] - 1);
	}

	li different_sums = possible_sums.size();

	auto res = (li)(different_sums * (different_sums + 1) / 2);

	for (size_t i = 0; i < dists.size(); ++i) {
		auto a_i = dists[i];
		res += 2 * (different_sums - i - 1) * a_i;
	}

	std::cout << res << std::endl;

	return 0;
}
