#include <iostream>
#include <vector>
#include <map>
#include <utility>
#include <cmath>
#include <algorithm>
using namespace std;

struct Point{
    long long x, y;
    Point(long long x0 = 0, long long y0 = 0) {
        x = x0;
        y = y0;
    }
};

Point main_(0, 0);

struct Vector {
    long long x, y;
    Vector(Point A, Point B) {
        x = B.x - A.x;
        y = B.y - A.y;
    }
    double len() {
        return sqrt((double) x * x + y * y);
    }
};

long long dot_product(Vector AB, Vector AC) {
    return AB.x * AC.x + AB.y * AB.y;
}

long long cross_product(Vector AB, Vector AC) {
    return AB.x * AC.y - AC.x * AB.y;
}


bool cmp(Point& left, Point& right) {
    if (cross_product(Vector(main_, left), Vector(main_, right)) == 0) {
        return Vector(main_, left).len() < Vector(main_, right).len();
    }
    return cross_product(Vector(main_, left), Vector(main_, right)) < 0;
}

vector<Point> need(vector<Point> a) {
    vector<Point> ans;
    ans.push_back(a[0]);
    ans.push_back(a[1]);
    for (int i = 2; i < a.size(); ++i) {
        while (ans.size() > 1 && cross_product(Vector(ans[ans.size() - 2], ans.back()), Vector(ans[ans.size() - 2], a[i])) >= 0) {
            ans.pop_back();
        }
        ans.push_back(a[i]);
    }
    return ans;
}

int main()
{
    cout << fixed;
    cout.precision(7);
    int n;
    long long l;
    cin >> n >> l;
    vector<Point> a(n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
    }
    vector<Point> ans;
    map<pair<int, int>, int> m;
    for (int i = 0; i < n; ++i) {
        int x = a[i].x, y = a[i].y;
        if (m[{x - l, y}] == 0) {
            m[{x - l, y}] = 1;
            Point ne(x - l, y);
            ans.push_back(ne);
        }
        if (m[{x + l, y}] == 0) {
            m[{x + l, y}] = 1;
            Point ne(x + l, y);
            ans.push_back(ne);
        }
        if (m[{x, y + l}] == 0) {
            m[{x, y + l}] = 1;
            Point ne(x, y + l);
            ans.push_back(ne);
        }
        if (m[{x, y - l}] == 0) {
            m[{x, y - l}] = 1;
            Point ne(x, y - l);
            ans.push_back(ne);
        }
    }

    for (int i = 1; i < ans.size(); ++i) {
        if (ans[i].x < ans[0].x || ans[i].x == ans[0].x && ans[i].y < ans[0].y) {
            swap(ans[0], ans[i]);
        }
    }
    main_.x = ans[0].x;
    main_.y = ans[0].y;
    sort(ans.begin() + 1, ans.end(), cmp);
    vector<Point> uf = need(ans);
    double s = Vector(uf[0], uf.back()).len();
    for (int i = 1; i < uf.size(); ++i) {
        s += Vector(uf[i - 1], uf[i]).len();
    }
    cout << s;
    return 0;
}
