#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>


using namespace std;
#define int long long
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define forn(i, n) for (int i = 0; i < (n); ++i)
#define nl() cout << '\n'
#define pb(x) push_back(x)
#define sz(x) (int)x.size()
#define vpii vector<pair<int, int>>
#define graph vector<vector<int>>

const int MAX = 1e5;

vi tree;
vpii edges;
graph g;

map<pii, bool> used;

void dfs(int v, int id) {

    while (!g[v].empty()) {
        int to = g[v].back();
        g[v].pop_back();

        if (used.count({min(v, to), max(v, to)})) continue;
        used[{min(v, to), max(v, to)}] = true;

        tree.pb(to);
        int nid = sz(tree) - 1;
        edges.push_back({id, nid});

        dfs(to, nid);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);

    forn (i, m) {
        int a, b;
        cin >> a >> b;
        g[--a].pb(--b);
        g[b].pb(a);
    }

    tree.push_back(0);
    dfs(0, 0);

    cout << sz(tree) << '\n';

    for (auto x : tree) {
        cout << x + 1 << ' ';
    }

    nl();

    for (auto x : edges) {
        cout << x.first + 1 << ' ' << x.second + 1 << '\n';
    }
    return 0;
}