#include <bits/stdc++.h>
#define x first
#define y second
//#define int long long
#define ld long double
using namespace std;

const long double pi = acos(-1);
const long double eps = 1e-9;

struct dot {
    long long x, y;
    dot()
    {
        x = 0;
        y = 0;
    }
    dot(long long _x, long long _y)
    {
        x = _x;
        y = _y;
    }
    dot operator+(dot p)
    {
        return dot(x + p.x, y + p.y);
    }
    dot operator-(dot p)
    {
        return dot(x - p.x, y - p.y);
    }
    long long operator%(dot p)
    {
        return x * p.y - y * p.x;
    }

    long long operator*(dot p)
    {
        return x * p.x + y * p.y;
    }

    dot operator*(long long k)
    {
        return dot{ x * k, y * k };
    }

    long double getlen()
    {
        return sqrt(x * x + y * y);
    }

    long long getsquarelen()
    {
        return x * x + y * y;
    }

    bool operator==(dot p)
    {
        return (p.x == x) && (p.y == y);
    }

    bool operator<(dot& p){
        if(x==p.x)
            return y<p.y;
        return x<p.x;
    }

    pair<long double, long double> normalize()
    {
        return make_pair(x / getlen(), y / getlen());
    }

    bool iscent(dot p1, dot p2)
    {
        if ((x <= p1.x && x >= p2.x) || (x >= p1.x && x <= p2.x)) {
            if ((y <= p1.y && y >= p2.y) || (y >= p1.y && y <= p2.y)) {
                return 1;
            }
        }
        return 0;
    }
};

bool iscent(dot p1, dot p2, pair<long double, long double> c)
{
    if ((c.x <= p1.x + eps && c.x + eps >= p2.x) || (c.x + eps >= p1.x && c.x <= p2.x + eps)) {
        if ((c.y <= p1.y + eps && c.y + eps >= p2.y) || (c.y + eps >= p1.y && c.y <= p2.y + eps)) {
            return 1;
        }
    }
    return 0;
}

dot infv = dot(LLONG_MAX, LLONG_MAX);

long double getangle(dot a, dot b)
{
    return atan2(a % b, a * b);
}

long double getgoodangle(dot a, dot b)
{
    long double res = atan2(a % b, a * b);
    if (res < 0)
        res += 2 * pi;
    return res;
}

double getverygoodangle(dot a, dot b)
{
    double res = atan2(a % b, a * b);
    if (res < 0)
        res += 2 * pi;
    if (res > pi)
        res = 2 * pi - res;
    return res;
}

struct line {
    long long a, b, c;
    dot on1, on2;
    line(dot p, dot q)
    {
        a = p.y - q.y;
        b = q.x - p.x;
        c = -a * p.x - b * p.y;
        on1 = p;
        on2 = q;
    }
    line(long long k, long long _b)
    {
        a = k;
        b = -1;
        c = _b;
        on1 = dot(1, a + c);
        on2 = dot(2, 2 * a + c);
    }
    line(long long _a, long long _b, long long _c)
    {
        a = _a;
        b = _b;
        c = _c;
    }
    bool ison(dot p)
    {
        if (abs(a * p.x + b * p.y + c) < eps)
            return 1;
        return 0;
    }
    pair<long double, long double> intersect(line l)
    {
        if (l.b != 0) {
            long double x = ((((long double)b) * l.c / l.b - c) / (a - ((long double)b) * l.a / l.b));
            long double y = (-x * l.a - l.c) / l.b;
            return make_pair(x, y);
        }
        else {
            long double x = -((long double)l.c) / l.a;
            long double y = (-x * a - c) / b;
            return make_pair(x, y);
        }
    }
};

long double getdist(line l, dot a)
{
    if (l.ison(a))
        return 1;
    dot parr = l.on1 - l.on2;
    dot norm = dot(-parr.y, parr.x);
    dot r = l.on1 - a;
    double ang = getverygoodangle(r, norm);
    if (ang > pi / 2) {
        norm = norm * -1;
        ang = pi - ang;
    }
    ang = pi / 2 - ang;
    return r.getlen() * sin(ang);
}

dot perp(line l, dot a)
{
    dot parr = l.on1 - l.on2;
    dot norm = dot(-parr.y, parr.x);
    dot r = l.on1 - a;
    double ang = getverygoodangle(r, norm);
    if (ang > pi / 2) {
        norm = norm * -1;
        ang = pi - ang;
    }
    ang = pi / 2 - ang;
    double dd = r.getlen() * sin(ang);
    dot ddd = norm * dd;
    return a + ddd;
}


signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, l;
    cin >> n >> l;
    vector<dot> ps(5*n);
    for (int i = 0; i < n; i++) {
        cin >> ps[5*i].x >> ps[5*i].y;

        ps[5*i+1].x = ps[5*i].x+l;
        ps[5*i+1].y = ps[5*i].y;

        ps[5*i+2].x = ps[5*i].x;
        ps[5*i+2].y = ps[5*i].y+l;

        ps[5*i+3].x = ps[5*i].x-l;
        ps[5*i+3].y = ps[5*i].y;

        ps[5*i+4].x = ps[5*i].x;
        ps[5*i+4].y = ps[5*i].y-l;

    }
    int mind = min_element(ps.begin(), ps.end()) - ps.begin();
    swap(ps[0], ps[mind]);
    sort(ps.begin() + 1, ps.end(), [&](dot& p, dot& q) {
        long long t = (p - ps[0]) % (q - ps[0]);
        if (t == 0)
            return (p - ps[0]).getlen() < (q - ps[0]).getlen();
        return t > 0;
    });
    vector<int> ch;
    ch.push_back(0);
    for (int i = 1; i < 5*n; i++) {
        while (ch.size() >= 2 && (ps[ch.back()] - ps[ch[ch.size() - 2]]) % (ps[i] - ps[ch[ch.size() - 2]]) <= 0)
            ch.pop_back();
        ch.push_back(i);
    }
    ld ans = 0;
    /*for(auto z:ch){
        cout << ps[z].x << " " << ps[z].y << "\n";
    }*/
    for(int i = 1; i<ch.size(); i++){
        int dx = (ps[ch[i]].x-ps[ch[i-1]].x);
        int dy = (ps[ch[i]].y-ps[ch[i-1]].y);
        ans+=sqrt((ld)(dx*dx+dy*dy));
    }
    int dx = (ps[ch[0]].x-ps[ch[ch.size()-1]].x);
    int dy = (ps[ch[0]].y-ps[ch[ch.size()-1]].y);
    ans+=sqrt((ld)(dx*dx+dy*dy));
    cout << setprecision(20) << ans;






    /*int n;
    cin >> n;
    ld v, u;
    cin >> v >> u;
    ld a[n];
    for(int i = 0; i<n; i++)
        cin >> a[i];
    ld l = 0, r = 1e9;
    while(r-l>1e-7){
        ld m = (r+l)/2;
        ld d = 0;
        for(int i = 0; i<n; i++){
            d+=max((ld)0.0, a[i]-m*v);
        }
        if(d+eps>=m*u)
            l = m;
        else r = m;
    }
    cout << setprecision(20) << l*u;*/
    return 0;
}
