#include <iostream>
#include <vector>
#include <cassert>
#include <set>
#include <algorithm>
using namespace std;
const int maxn = 1e5+17;
vector<int> g[maxn];
struct DSU {
    vector<int> sz, pr;
    vector<vector<int>> child;
    DSU(int n){
        sz.resize(n + 1, 1);
        pr.resize(n + 1);
        child.resize(n + 1);
        for (int i = 0; i < n+1; ++i) {
            pr[i] = i;
            child[i].push_back(i);
        }
    }
    int find(int x) {
        return x == pr[x] ? x : pr[x] = find(pr[x]);
    }
    bool same(int x, int y) {
        return find(x) == find(y);
    }
    void unite(int x, int y) {
        x = find(x);
        y = find(y);
        if (x == y) return;
        if (sz[x] > sz[y]) swap(x, y);
        for (auto u : child[x]) {
            child[y].push_back(u);
        }
        //sz[x] <= sz[y]
        sz[y] += sz[x];
        pr[x] = y;
    }
};
bool used[maxn];
DSU dsu(maxn);
vector<pair<int, int>> edges;
int cnt1;
set<pair<int, int>> st;
void dfs(int v, int p = -1) {
    used[v] = 1;
    for (auto u : g[v]) {
        if (u == p) continue;
        if (used[u]) {
            if (st.find({min(u, v), max(u, v)}) != st.end()) continue;
            cnt1++;
            cerr << u << " " << v << '\n';
            st.insert({min(u,v ), max(u, v)});
            edges.push_back({v, cnt1});
            dsu.unite(u, cnt1);
        } else {
            edges.push_back({u, v});
            dfs(u, v);
        }
    }
}
int main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    int cnt = 1;
    cnt1 = n;
    dfs(1);
    vector<bool> was(cnt1 + 1);
    vector<int> color(cnt1 + 1, -1);
    for (int i = 1; i <= cnt1; ++i) {
        int cur = dsu.find(i);
        if (was[cur]) continue;
        was[cur] = 1;
        for (auto u : dsu.child[cur]) {
            color[u] = cnt;
        }
        cnt++;
    }
    cout << cnt1 << '\n';
    for (int i = 1; i <= cnt1; ++i) {
        assert(color[i] != -1);
        cout << color[i] << ' ';
    }
    cout << '\n';
    for (auto u : edges) {
        cout << u.first << " " << u.second << '\n';
    }
}