﻿//------------------------------Includes------------------------------//

#include <cstdlib>
#include <ctime>
#include <climits>
#include <string>
#include <array>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdio>

//------------------------------Namespaces------------------------------//

using namespace std;

//------------------------------Defines And Typedefs------------------------------//

typedef long long ll;
typedef long double ld;
typedef double db;
typedef unsigned long long ull;

#define mpr make_pair
#define f first
#define s second

#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) (x).rbegin(), (x).rend()
#define ft front()
#define bk back()
#define pf push_front 
#define pb push_back

#define pi pair<int, int>
#define pl pair<long, long>
#define pd pair<db, db>
#define vi vector<int>
#define vb vector<bool>
#define vl vector<ll>
#define vul vector<ull>
#define vd vector<db>;
#define vs vector<string>;
#define vc vector<char>;
#define vpi vector<pi>;
#define vpl vector<pl>;
#define vpd vector<pd>;

#define FOR(i,a) for (int i=0;i<(a);++i)
#define FORD(i,a) for (int i=(a)-1;i>=0;i--)
#define FORT(i,a,b) for (int i=(a);i<(b);++i)
#define FORTD(i,b,a) for (int i=(b)-1;i>=(a);--i)
#define trav(i,v) for (auto i : v)

//------------------------------Functions------------------------------//

template <typename T>
istream& operator >>(istream & input, vector<T> & a) {
	FOR(i, sz(a)) {
		input >> a[i];
	}
	return input;
}

template <typename T>
ostream& operator <<(ostream & output, vector<T> & a) {
	FOR(i, sz(a)) {
		output << a[i] << ' ';
	}
	return output;
}

template <typename T>
T binary_search(T array[], T start, T end, T key) {
	if (start <= end) {
		T mid = (start + (end - start) / 2);
		if (array[mid] == key)
			return mid;
		if (array[mid] > key)
			return binary_search(array, start, mid - 1, key);
		return binary_search(array, mid + 1, end, key);
	}
	return -1;
}

template <typename T>
T phi(T n) {
	T result = n;
	for (T i = 2; i * i <= n; ++i)
		if (n % i == 0) {
			while (n % i == 0)
				n /= i;
			result -= result / i;
		}
	if (n > 1)
		result -= result / n;
	return result;
}

template <typename T>
T binpow(T a, T n) {
	if (n == 0)
		return 1;
	if (n % 2 == 1)
		return binpow(a, n - 1) * a;
	else {
		T b = binpow(a, n / 2);
		return b * b;
	}
}

template <typename T>
T gcd(T a, T b) {
	return b ? gcd(b, a % b) : a;
}

template <typename T>
T lcm(T a, T b) {
	return a / gcd(a, b) * b;
}

template <typename T>
bool is_prime(T n) {
	if (n == 1 || n == 0) return false;
	if (n == 2) return false;
	if (!(n % 2)) return true;
	for (T i = 3; i * i <= n; i += 2)
		if (!(n % i))
			return false;
	return true;
}

template <typename T>
vi primes(T n) {
	vb prime(n + 1, true);
	prime[0] = prime[1] = false;
	FORT(i, 2, n + 1)
		if (prime[i])
			if (i * 1ll * i <= n)
				for (int j = i * i; j <= n; j += i)
					prime[j] = false;
	vi prime_nums;
	FOR(i, n + 1) {
		if (prime[i]) {
			prime_nums.pb(i);
		}
	}
	return prime_nums;
}

//------------------------------Solution------------------------------//

void solve() {
	int a, b;
	cin >> a >> b;
	if (a >= b) {
		cout << b << endl;
	}
	else {
		cout << a + 1 << endl;
	}
}

int main() {
	ll t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}