#include <bits/stdc++.h>

using namespace std;
struct segment_tree{
    int sz = 1;
    struct progression{
        int a0, step;
        bool invalid = true;
        progression(int a0, int step) : a0(a0), step(step){}
          };
    vector<progression> assigned;
    segment_tree(int n){
        while (sz < n) sz *= 2;
        assigned.assign(sz * 2, {0, 0});
    }
    int get(int i){return get(i, 0, sz, 1); }
    int get(int i, int sl, int sr, int si){
        if (i == sl && sl + 1 == sr){
            return assigned[si].a0;
        }
        int m = (sl + sr) / 2;
        push(si, m - sl);
        if (i < m) return get(i, sl, m, si * 2); else return get(i, m, sr, 2 * si + 1);
    }
    void update(int l, int r, int v,int step) { update(l, r, v,step, 0, sz, 1);}

    void update(int l, int r, int v, int step, int sl, int sr, int si){
        if (r <= sl || sr <= l) return;
        if (l <= sl && sr <= r){
            assigned[si] = {v+(sl-l)*step, step};
            assigned[si].invalid =false;
            return;
        }
        int m = (sl + sr) / 2;
        push(si, m - sl);
        update(l, r, v, step, sl, m, 2 * si);

        update(l, r, v, step, m, sr, 2 * si + 1);
    }

    void push(int i, int len){
        if (assigned[i].invalid) return;
        assigned[2 * i] = assigned[i];
        assigned[2 * i + 1] = assigned[i];
        assigned[2 * i + 1].a0 += assigned[2 * i + 1].step * len;
        assigned[i].invalid = true;
        assigned[2*i].invalid = false;
        assigned[2*i+1].invalid = false;
    }
};

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> q;
    segment_tree x(n), y(n);
    for (int i = 0; i < n; ++i) x.update(i, i + 1, i + 1, 0);
    for (int i = 0; i < n; ++i) y.update(i, i + 1, 0, 0);

    for (int j = 0; j < q; ++j){
        int t;
        cin >> t;
        if (t == 1){
            int l, r;
            cin >> l >> r;
            --l, --r;
            int x1 = x.get(l);
            int x2 = x.get(r);
            int y1 = y.get(l);
            int y2 = y.get(r);
            if (x1 == x2){
                x.update(l, r + 1, x1, 1);
                y.update(l, r + 1, y1, 0);
            } else {
                x.update(l, r + 1, x1, 0);
                y.update(l, r + 1, y1, 1);
            }
        } else {
            int i;
            cin >> i;
            --i;
            cout << x.get(i) << ' ' << y.get(i) << '\n';
        }
    }
}
