#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <iomanip>

using namespace std;

#define int long long

typedef long long ll;

struct pt {
    ll x, y;

    pt() {}

    pt(ll _x, ll _y) {
        x = _x, y = _y;
    }

    ll operator%(const pt &oth) const {
        return x * oth.x + y * oth.y;
    }

    ll operator*(const pt &oth) const {
        return x * oth.y - y * oth.x;
    }

    pt operator-(const pt &oth) const {
        return pt(x - oth.x, y - oth.y);
    }

    bool operator<(const pt &oth) {
        if (y != oth.y) return y < oth.y;
        return x < oth.x;
    }
};

bool cmp(const pt &a, const pt &b) {
    ll vc = a * b;
    ll la = a % a;
    ll lb = b % b;
    if (vc == 0) return la > lb;
    return vc > 0LL;
}

typedef long double ld;

ld getAngle(const pt &a, const pt &b) {
    return atan2l(a * b, a % b);
}

ld getLength(const pt &a) {
    return sqrtl((ld) (a.x * a.x + a.y * a.y));
}

vector<pt> ch(vector<pt> &a) {
    int n = a.size();
    pt q = a[0];

    for (int i = 0; i < n; i++) {
        if (a[i] < q) q = a[i];
    }

    for (int i = 0; i < n; i++) {
        a[i] = a[i] - q;
    }

    sort(begin(a), end(a), cmp);

    int m = 0;
    vector<pt> ans;
    for (int i = 0; i < n; i++) {
        //cerr << "step: " << i << '\n';
        //for (auto& i : ans) cerr << i.x << ' ' << i.y << '\n';
        //cerr << a[i].x << ' ' << a[i].y << '\n';
        while (m >= 2 && ((ans[m - 1] - ans[m - 2]) * (a[i] - ans[m - 2])) <= 0LL) {
            ans.pop_back();
            m--;
        }
        ans.emplace_back(a[i]);
        m++;
    }

    return ans;
}

#define ff first
#define ss second

void solve() {
    ld pi = acosl(-1);

    int n, k;
    cin >> n >> k;
    vector<pt> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    a = ch(a);

    n = a.size();
//    for (int i = 0; i < n; i++){
//        cout << a[i].x << ' ' << a[i].y << '\n';
//    }
    ld res = 0;
    ld res2 = 0;
    for (int i = 0; i < n; ++i) {
        int ii = (i + 1) % n;
        int iii = (i + 2) % n;

        pt p1 = a[i];
        pt p2 = a[ii];
        pt p3 = a[iii];

//        pt g = p2 - p3;
//        pt h = p2 - p1;
//
//        pair<ld, ld> gn = {-g.y, g.x};
//        pair<ld, ld> hn = {h.y, -h.x};
//        ld gnl = sqrtl(gn.ff * gn.ff + gn.ss * gn.ss);
//        ld hnl = sqrtl(hn.ff * hn.ff + hn.ss * hn.ss);
//        gn.ff /= gnl;
//        gn.ss /= gnl;
//        hn.ff /= hnl;
//        hn.ss /= hnl;
//
//        gn.ff *= k;
//        gn.ss *= k;
//        hn.ff *= k;
//        hn.ss *= k;

//        res += sqrtl((gn.ff - hn.ff) * (gn.ff - hn.ff) + (gn.ss - hn.ss) * (gn.ss - hn.ss));

        res += getLength(p1 - p2);
//        cerr << getLength(p1 - p2) << endl;
        // 1365685424.949237823486328125

//        pt v1 = p1 - p2;
//        pt v2 = p3 - p2;
//        ld angle = pi - abs(getAngle(v1, v2));
//        res2 += (sinl(angle / 2));
    }

    res += n * sqrtl(2) * (ld) k;
    if (n % 2) {
        res += sqrtl(2) * (ld) k;
    }

    res2 *= 2.0L * (ld) k;

    cout << setprecision(239) << fixed << res;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}