import java.util.Scanner;

public class ProblemL {

    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);
        int magnetsSize = scan.nextInt();
        int querySize = scan.nextInt();

        Point[] magnets = new Point[magnetsSize];
        for (int i = 0; i < magnetsSize; i++) {
            magnets[i] = Point.NullPoint(i);
        }

        Query[] queries = new Query[querySize];
        for (int i = 0; i < querySize; i++) {
            int type = scan.nextInt();
            if (type == 1) queries[i] = new Query(type, scan.nextInt(), scan.nextInt());
            if (type == 2) queries[i] = new Query(type, scan.nextInt());
        }
        for (int i = 0; i < querySize; i++) {
            magnets = doQuery(magnets, queries[i]);
            System.out.println("HI");
        }
    }

    private static Point[] doQuery(Point[] magnets, Query query) {
        if (query.type == 1) return queryOne(magnets, query.l, query.r);
        if (query.type == 2) return queryTwo(magnets, query.cor - 1);

        return magnets;
    }

    private static Point[] queryOne(Point[] magnets, int l, int r) {
        long x0 = magnets[l - 1].x;
        long y0 = magnets[l - 1].y;
        if (horizontal(magnets, l, r)) {
            for (int i = l; i <= r; i++) {
                magnets[i].y = magnets[i].x - x0;
                magnets[i].x = x0;
            }
        } else {
            for (int i = l + 1; i <= r; i++) {
                magnets[i].x = x0+magnets[i].y;
                magnets[i].y = y0;

            }
        }
        System.out.println(magnets[3].x + " " + magnets[3].y);
        return magnets;
    }

    private static boolean horizontal(Point[] magnets, int l, int r) {
        boolean res = true;
        for (int i = l+1; i <= r; i++) {
            if (magnets[i].y != magnets[i - 1].y) {
                res = false;
                break;
            }
        }

        return res;
    }

    private static Point[] queryTwo (Point[]magnets, int cor){
            long x = magnets[cor - 1].x;
            long y = magnets[cor - 1].y;
            System.out.println(x + " " + y);

            return magnets;
        }
    }

    class Query {
        public int type;
        int r = -1;
        int l = -1;
        int cor = -1;

        public Query(int type, int l, int r) {
            this.type = type;
            this.l = l;
            this.r = r;
        }

        public Query(int type, int cor) {
            this.type = type;
            this.cor = cor + 1;
        }


    }

    class Point {
        public long x;
        public long y;

        public static Point NullPoint(long x) {
            return new Point(x, 0);
        }

        public Point(long x, long y) {
            this.x = x;
            this.y = y;
        }
    }
