#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <deque>

using namespace std;

typedef long long ll;
typedef pair<int, int> point;
#define x first
#define y second

template <class T = int>
T next() { T x; cin >> x; return x; }

double sdist(point p1, point p2)
{
    return sqrt(((double)p1.x - p2.x) * ((double)p1.x - p2.x) + ((double)p1.y - p2.y) * ((double)p1.y - p2.y));
}

ll prod(point p1, point p0, point p2)
{
    point p11 = { p1.x - p0.x, p1.y - p0.y };
    point p22 = { p2.x - p0.x, p2.y - p0.y };
    return (ll)p11.x * (ll)p22.y - (ll)p11.y * (ll)p22.x;
}

double special_func(vector<point>& points)
{
    int curr = 0, p = -1;
    vector<bool> used(points.size(), false);
    vector<int> shell;

    for (int i = 0; i < points.size(); i++)
        if (points[i] < points[curr])
            curr = i;

    shell.push_back(curr);

    while (true)
    {
        int nxt = -1;

        for (int i = 0; i < points.size(); i++)
            if (!used[i] && i != p && i != curr)
            {
                nxt = i;
                break;
            }
        
        if (nxt == -1)
            break;

        for (int i = 0; i < points.size(); i++)
            if (!used[i] && i != p && i != curr)
            {
                ll pr = prod(points[nxt], points[curr], points[i]);

                if (pr > 0 || (pr == 0 && sdist(points[i], points[curr]) > sdist(points[nxt], points[curr])))
                    nxt = i;
            }

        shell.push_back(nxt);
        used[nxt] = true;
        if (nxt == shell.front())
            break;
        p = curr;
        curr = nxt;
    }
    
    double dist = 0;
    for (int i = 0; i < shell.size() - 1; i++)
        dist += sdist(points[shell[i]], points[shell[i + 1]]);
   
    return dist;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout.precision(20);

    int n, l, x, y;
    cin >> n >> l;
    std::vector<pair<int, int>> pts;
    pts.reserve(n * 4);
    while (n--)
    {
        cin >> x >> y;
        pts.emplace_back(x, y + l);
        pts.emplace_back(x, y - l);
        pts.emplace_back(x - l, y);
        pts.emplace_back(x + l, y);
        //pts.emplace_back(x, y);
    }
    std::cout << special_func(pts);

    return 0;
}