#include <bits/stdc++.h>
using namespace std;

#define f first
#define s second

const int N   = 1e6 + 7;
const int INF = 1e18 + 7;

struct edges {
    int u, v;
};

int p[N], rk[N], col[N];
set<int> g[N];
vector<edges> e, q;


void Init_Dsu() {

    for(int i = 0;i < N; ++i) {
        p[i] = i;
        rk[i] = 1;
    }
}

int Root(int v) {
    if(p[v] == v)
        return v;
    return p[v] = Root(p[v]);
}

bool comb(int a, int b) {
    a = Root(a);
    b = Root(b);

    return a == b;
}

void Unite(int a, int b) {

    a = Root(a);
    b = Root(b);

    if(rk[a] < rk[b])
        swap(a, b);

    p[b] = a;
    rk[a] += rk[b];
}

int nxt = 1;
bool used[N];
void dfs(int v) {
    col[v] = nxt++;
    used[v] = true;

    for(auto x : g[v]) {
        if(!used[x])
            dfs(x);
    }
}

bool u1[N];
void dfs1(int v, int pr) {

    u1[v] = true;
    if(v != pr) {
        cout << pr << " " << v << '\n';
    }

    for(auto x : g[v]) {
        if(!u1[x])
            dfs1(x, v);
    }
}

ostream& operator << (ostream& out, edges x) {
    out << x.u << " " << x.v;
    return out;
}

int32_t main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cout << fixed << setprecision(6);

//    freopen("input.txt","r",stdin);
//    freopen("output.txt","w",stdout);

    Init_Dsu();

    int n, m;
    cin >> n >> m;

    for(int i = 0;i < m; ++i) {
        edges a;
        cin >> a.u >> a.v;

        e.push_back(a);
        q.push_back(a);
    }

    int sz = 0, t = 1;
    while(!e.empty()) {
        edges cur = e.back();
        e.pop_back();

        if(!comb(cur.u, cur.v)) {
            Unite(cur.u, cur.v);
            g[cur.u].insert(cur.v);
            g[cur.v].insert(cur.u);
        }
    }

    for(int i = 1;i <= n; ++i)
        col[i] = i;

    int add = n + 1;
    for(int i = 0;i < q.size(); ++i) {
        if(!g[ q[i].v ].count(q[i].u)) {
            col[add] = col[ q[i].u ];
            g[ q[i].v ].insert(add++);
        }
    }

    add -= 1;
    cout << add << '\n';
    for(int i = 1;i <= add; ++i)
        cout << col[i] << " ";
    cout << '\n';

    dfs1(1, 1);

    cout << '\n';
}
