#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <cstdlib>
#include <queue>
#include <deque>
#include <tuple>
#include <cassert>
#include <cstring>

using namespace std;

#define fi first
#define se second
#define int long long


template <typename T,typename S>
istream& operator >>(istream& in, pair<T,S> &m) {
    in >> m.fi >> m.se;
    return in;
}

template <typename T>
istream& operator >>(istream& in, vector<T> &m) {
    for (int i=0,l=m.size();i<l;++i)
        in >> m[i];
    return in;
}

template <typename T,typename S>
ostream& operator <<(ostream& out, pair<T,S> &m) {
    out << m.fi << ' ' << m.se;
    return out;
}

template <typename T>
ostream& operator <<(ostream& out, vector<T> &m) {
    for (int i=0,l=m.size();i<l;++i)
        out << m[i] << ' ';
    return out;
}


void simple_solution(int S, const vector<int>& a)
{
    int n = a.size();
    double S2 = 1.0 * S / 2;
    pair<int, int> p;
    unsigned long long res = 0;
    for (int i = 0; i < n; i++)
    {
        p.first = 0; p.second = 0;
        for (int j = 0; j < n; j++)
        {
            if (j == i)
            {
                continue;
            }
            if (a[j] > a[i] || a[j] <= fmod(a[i] + S2, S))
            {
                if (a[j] == fmod(a[i] + S2, S))
                {
                    p.second++;
                }
                p.first++;
            }
            else
            {
                if (a[j] == fmod(a[i] + S2, S))
                {
                    p.first++;
                }
                p.second++;
            }
        }
        res += p.first * p.second;
    }
    cout << '<' << res / 3 << '>' << endl;
}

vector<vector<int>> gr;
vector<int> used, dot;

void dfs(int v, int h=2) {
    if (h == 0) {
        used[v] = 2;
        return;
    }
    used[v] = 1;
    for (int i : gr[v]) {
        if (used[i] != 1) {
            dfs(i, h-1);
        }
    }
}


/*
void solution0()
{
    int n, L;
    cin >> n >> L;
    vector<int> x(n);
    for (int i = 0; i < n; i++)
    {
        cin >> x[i];
    }
    simple_solution(L, x);
    sort(x.begin(), x.end());
    // start: simple for x[0]
    for (int i = 1; i < n; i++)
    {
        if (x[i] > x[0] || x[i] <= fmod(a[i] + L2, L))
        {
            if (a[j] == fmod(a[i] + S2, S))
            {
                p.second++;
            }
            p.first++;
        }
        else
        {
            if (a[j] == fmod(a[i] + S2, S))
            {
                p.first++;
            }
            p.second++;
        }
        res += p.first * p.second;
    }
}*/

struct point
{
    int x, y;
    point (int a=0,int b=0) {
        x = a;
        y = b;
    }
    int operator *(point p) { // dot (cos)
        return x*p.x + y * p.y;
    }
    int operator ^(point p) { // cross (sin)
        return x*p.y - y*p.x;
    }
    int len2() {
        return x*x + y*y;
    }

    bool operator !=(point a) {
        return (x != a.x || y != a.y);
    }

};

point start;

point operator -(point a,point b) {
    return point(a.x-b.x,a.y-b.y);
}

bool operator <(point a,point b) {
    a = a - start;
    b = b - start;
    if ((a^b) != 0) {
        return (a^b) > 0;
    } else {
        return a.len2() < b.len2();
    }

}

istream& operator >>(istream& in,point &a) {
    in >> a.x >> a.y;
    return in;
}

ostream& operator <<(ostream& out,point a) {
    out << a.x << ' ' << a.y;
    return out;
}

void solution()
{
    int n, L;
    cin >> n >> L;
    set<pair<int,int>> A;
    vector<point> p;

    for (int i=0;i<n;++i) {
        int xx, yy;
        cin >> xx >> yy;
        //xx)
        A.insert({xx,yy});
        A.insert({xx,yy-L});
        A.insert({xx,yy+L});
        A.insert({xx+L,yy});
        A.insert({xx-L,yy});
    }
    //cout << A.size() << endl;
    for (pair<int,int> i : A) {
        //cout << i << endl;
        p.push_back(point(i.first,i.second));
    }

    start = p[0];

    for (int i=1;i<p.size();++i) {
        if (p[i].x < start.x) {
            start = p[i];
        }
        if (p[i].x == start.x && p[i].y < start.y) {
            start = p[i];
        }
    }

    sort(p.begin(),p.end());

    vector<point> ans;

    ans.push_back(p[0]);

    for (int i=1;i<p.size();++i) {
        while (ans.size() > 1) {
            int t = ans.size()-1;
            if ( ((ans[t]-ans[t-1])^(p[i]-ans[t])) <= 0 ) {
                ans.pop_back();
            } else {
                break;
            }
        }
        ans.push_back(p[i]);
    }
    for (auto i : ans) {
     //   cout << i << endl;
    }
    double pp = 0;
    for (int i = 0; i < ans.size(); ++i) {
        int i1 = i%ans.size(), i2 = (i+1)%ans.size();
        pp += sqrt(point(ans[i1]-ans[i2] ).len2());
    }
    cout << setprecision(15) << pp;
    //for (point i : ans) cout << i << endl;

}

int32_t main()
{
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solution();
}




/*
                                                              ..---..._
                                                        ..--""         "-.
                                                   ..-"""                 ".
                                               ..-""                        "
                                            .-"
                                         .-"      ... -_
                                     .="   _..-" F   .-"-.....___-..
                                     "L_ _-'    ."  j"  .-":   /"-._ "-
                                        "      :  ."  j"  :   :    |"" ".
                                  ......---------"""""""""""-:_     |   |\
                        ...---""""                             -.   f   | "
                ...---""       . ..----""""""""..                ".-... f  ".
         ..---"""       ..---""""""""-..--"""""""""^^::            |. "-.    .
     .--"           .mm::::::::::::::::::::::::::...  ""L           |x   ".
   -"             mm;;;;;;;;;;XXXXXXXXXXXXX:::::::::::.. |           |x.   -
 xF        -._ .mF;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXX:::::::|            |X:.  "
j         |   j;;;;;XXX#############################::::::|            XX::::
|          |.#;::XXX##################################::::|            |XX:::
|          j#::XXX#######################################::             XXX::
|         .#:XXX###########################################             |XX::
|         #XXX##############################XX############Fl             XXX:
|        .XXX###################XX#######X##XXX###########Fl             lXX:
 |       #XX##################XXX######XXXXXXX###########F j             lXXX
 |       #X#########X#X#####XXX#######XXXXXX#######XXX##F  jl            XXXX
 |       #X#######XX#"  V###XX#' ####XXXXXX##F"T##XXXXXX.  V   /  .    .#XXXX
  |       #########"     V#XX#'  "####XXXX##.---.##XXXXXX.    /  /  / .##XXXX
  |       "######X' .--"" "V##L   #####XXX#"      "###XXXX. ."  /  / .###XXXX
  |         #####X "   .m###m##L   ####XX#      m###m"###XX#   /  / .#####XXX
   |         "###X   .mF""   "y     #####     mX"   "Y#"^####X   / .######XXX
   |           "T#   #"        #     ####    X"       "F""###XX"###########XX
   |             L  d"     dXX  xm   "^##L mx     dXX  YL-"##XX"S""##########
    |            xL J     Xd%    T      ""  T    XdX    L. "##XS.f |#########
    |             BL      X## X                  X## X      T#SS"  |#########
    |              #L     X%##X                  X%##X|     j#SSS /##########
     |              #L  ._ TXXX-"           "-._  XXXF.-    ###SS\###########
     |              ##   """""                  """"""      ##DS.\###########
     |              TF                                      ##BBS.T#########F
      |             #L           ---                        ###BBS.T########'
      |            '##            ""                     jL|###BSSS.T#######
       |          '####             ______              .:#|##WWBBBSS.T####F
      J L        '######.            \___/            _c::#|###WWWBSSS|####
     J ;;       '########m                           c:::'#|###WWWBBSS.T##"
    J ;;;L      :########.:m.          _          _cf:::'.L|####WWWWSSS|#"
  .J ;;;;B      ########B....:m..             _,c%%%:::'...L####WWWBBSSj
 x  ;;;;dB      #######BB.......##m...___..cc%%%%%::::'....|#####WWBBDS.|
" ;;;;;ABB#     #######BB........##j%%%%%%%%%%%%%%:::'..... #####WWWWDDS|
.;;;;;dBBB#     #######BB.........%%%%%%%%%%%%%%%:::'...   j####WWWWWBDF
;;;;;BBB####    ######BBB.........%%%%%%%%%%%%%%:::'..     #####WWWWWWS
;;;;dBBB####    ######BBB..........^%%%%%%%%%%:::"         #####WWWWWWB
;;;:BBB######   X#####BBB"..........."^YYYYY::"            #####WWWWWWW
;;.BB#########  X######BBB........:''                      #####WWWWWWW
;;BB##########L X######BBB.......mmmm..                 ..x#####WWWWWWB.
;dBB########### X#######BB.....        "-._           x""  #####WWWWWWBL
;BBB###########L X######BB...              "-              ######WWWWBBBL
BBB#############. ######BBB.                                #####WWWWBBBB
BBB############## X#####BBB                                 #####WWWWWBBB
BBB############### T#####BB                                  #####WWWBBB     :
BB################# T###BBP                                   #####WWBB"    .#
BB##################..W##P                                      ###BBB"    .##
BB###################..l                                         "WW"      ###
BB####################j ___                                        " l    j###
BBB##################J_-   """-..             ':::'   .-""""""""""-.  l  .####
BBB######B##########J########    "-.           ::'  -" ..mmm####mm.."-.< #####
MCL-5/7/88 BBB#####J############    "-_        :|  " .###############mmLlR####
BBBBBBBBBBBBBBB###/         #######    -.     .:| ".#####F^^^P^^"""^^^Y#lT####
BBBBBBBBBBBBBBBBBj|####mm        ######xx-...:::|" ###f      .....      "#T###
BBBBBBBBBBBBBBBBjj##########mm..           ":::."j##F  .mm#########mmm.. Yj###
BBBBBBBBBBBBBBBB|^WWWSRR############mmmmm xx """mjF.mm####################j###
BBBBBBBBBBBBBBBB|                      ######mmmmmm#######################j###
BBBBBBBBBBBBBBBBY#m...   ..mmm##########PPPPP#####m..                    lj###
BBBBBBBBBBBBBBBBB2##############^^""     ..umF^^^Tx ^##mmmm........mmmmmmlj###
BBBBBBBBBBBBBBBBBJT######^^^""     .mm##PPPF"...."m.  "^^###############lj####
BBBBBBBBBBBBBBBBB##^L         .mmm###PPP............"m..    """"^^^^^"" lj####
BBBBBBBBBBBBBBBB#####Y#mmx#########P.................."^:muuuummmmmm###^.#####
BBBBBBBBBBBBBBBB#####::Y##mPPPPF^".......|.............. ""^^######^^"...#####
BBBBBBBBBBBBBB########..................F............      \     ........#####
BBBBBBBBBBBBB#########.................|..........          :       ....l#####
BBBBBBBBBBBB###########...............F.........             \        ..######
BBBBBBBBBBB#############.............|........                :         dA####
BBBBBBBBBB##############.....................                           kM####
BBBBBBBBB################..................                             k#####
BBBBBBB##################................                               k#####
BBBBB#####################.............                                 t#####
BB########################............                                  "E####
B########################F............                           .       "####
#########################............'      |                    ..       "L##
########################F............                           ...        "L#
#######################F............'                           .....       "#
######################F.............                           .......       "
#####################$..............                         .........
#####################lmmm.............                      ...........   ..m#
####################j########mmmm.............            ......mmmmmm########
###################j###::::;:::::########mmmmmmm##############################
##################j:::::::;:::::::;;::##############################^^^""""
##################.mm:::mmm######mmmm:::' ^^^^^^""#######^^""""
#################F...^m::;::################mmm  .mm"""
#################.......m;::::::::::::#########^"
################F.........###mmm::::;' .##^"""
 ##############F...........:#######m.m#"
   ############..............':####
     #########F............mm^""
       #######..........m^""
          ####.......%^"
             #.....x"
             |.x""
            .-"
          .-
        .-
      .-
     -
   -"
 -"
"
                                                                             x
                                                                           xx
                                                                         xx
                                                                     xxx"
                                                                 xxx"
                                                           .xxxx"
                                                   ___xxx""
                                             .xxxx""....F
                """"mmxxxxx          ___xxx^^^..........'
                   .xx^^^^YYYY###xxx^^.................|
                .xx^"        #######x..................|
             .xx"          ###########mx..............f
           .x^            ##############xx............|
          j"             ##############    x..........;
.........#              ############       #x.........|
x.......j"              ##########       ####x.......f
 xxx....#..            ########        #######x......|
   xxxx.#....         #######        ##########x.....|
      xxx......       #####         #########   x....|
         xxx......    ###          #######      #m...|
           xxx......  ##           ######      ####..|
             xxx......#.          #####       ######m|
               xxxx.......        ###        #######Fx
                   xxx......      #         j#####    m
                      xx......              ####      Jxm
                       xxx......           ####      j###Km
                          xxx.....         ###      j####F  m
                             xx......       #       ###F    .m
                               xxx ....            j##F    .###m
                               m..xx.....          ##F    j#####K^mm.
                                m...xx......       ##     #####F    ####mm
                                m .....x......     F     j####F    ########
                                 m  ......x.....         ###F    J##########
                                 "m  ........x....      .#F     #########^^|
                                  "......mmF^^^x....    ##     ######      |
                                   lL..jF        x.... .F      ####       |
                                   lTLJF           x....      ####        |
                                   l::|.            "....    j###       ##
                                    l....            L....   ###F     x##
                                     l....       ..m##L...   ##F     j###
                                     l:...        #####L...  #F     j####
                                      l....    ####     ...        #####
                                      "....              ...       ####F |
                                       l....              ...     j###F  |
                                        #...               ....   ###F    |
                                        "#..              .jL.... ##F     |
                                         ##.            .m###L....#F      |
                                         "##        ..mm###### ....       |
                                          |                   |...        |
                                          k                    |...       |
                                          l                    |...       k
                                           k                 .m#L...     Jk
                                           ##            ..mm####L...     k
                                           ###         d########' L....   |
                                           l                   |   "-.__-"
                                           l                   |
                                           l                  j#
                                           :                 j##
                                            k               j##'
                                            l            .m###k
                                            l           ###^^"|
                                            |                 |
                                            j               .##
                                            |              ######
                                            |==          ##### ####
                                           .k          #####"   ####
                                           l         #####^     ####
                                           l       ###         ####'
                                           !                 m###F
                                           |               ######
                                           |           mm##m###'
                                           |.       m########F
                                           |.    m#######F" #
                                           d.   ###        #
                                          |..             .'
                                          |..             |
                                           k..           :
                                           \...          F
                                            |...        #d
                                            |...       ###
                                             L...     ####.
                                             |...    j### |
                                              L...   ###  |
                                              T...  j##    k
                                               \... ##     |
                                                 \...      .
                                                   "^-____-
*/