#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define ld long double
#define db double
#define pb push_back
#define all(x) begin(x), end(x)
#define SZ(x) (int)(x).size()
#define cps(x) sort(all(x)), (x).erase(unique(all(x)), end(x))
#define cps2(x, y) sort(all(x), y), (x).erase(unique(all(x)), end(x))
#define mem(x, y) memset(& x, y, sizeof(x))
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const int n0 = 1e5 + 123;
int n, l;

struct pt {
    int x, y;
    pt operator - (const pt & p) {
        pt res;
        res.x = x - p.x;
        res.y = y - p.y;
        return res;
    }
    ll sq() {
        return (ll)x * x + (ll)y * y;
    }
};

bool cmp(pt a, pt b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool cw(pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}

bool ccw(pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}

void convex_hull(vector<pt>& a) {
    if (a.size() == 1)
        return;

    sort(a.begin(), a.end(), &cmp);
    pt p1 = a[0], p2 = a.back();
    vector<pt> up, down;
    up.push_back(p1);
    down.push_back(p1);
    for (int i = 1; i < (int)a.size(); i++) {
        if (i == a.size() - 1 || cw(p1, a[i], p2)) {
            while (up.size() >= 2 && !cw(up[up.size()-2], up[up.size()-1], a[i]))
                up.pop_back();
            up.push_back(a[i]);
        }
        if (i == a.size() - 1 || ccw(p1, a[i], p2)) {
            while(down.size() >= 2 && !ccw(down[down.size()-2], down[down.size()-1], a[i]))
                down.pop_back();
            down.push_back(a[i]);
        }
    }

    a.clear();
    for (int i = 0; i < (int)up.size(); i++)
        a.push_back(up[i]);
    for (int i = down.size() - 2; i > 0; i--)
        a.push_back(down[i]);
}

ld dist(pt & x, pt & y) {
    pt res = y - x;
    return sqrt(res.sq());
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	//freopen("input.txt", "r", stdin);
    cin >> n >> l;
    vector <pt> v;
    pt p;
    for (int i = 0; i < n; i++) {
        int x, y; cin >> x >> y;
        p.x = x - l, p.y = y;
        v.pb(p);
        p.x = x + l, p.y = y;
        v.pb(p);
        p.x = x, p.y = y - l;
        v.pb(p);
        p.x = x, p.y = y + l;
        v.pb(p);
    }
    convex_hull(v);
    ld res = 0;
    for (int i = 0; i < SZ(v); i++) {
        res += dist(v[i], v[(i + 1) % SZ(v)]);
    }
    cout << fixed << setprecision(20) << res;
}
