#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <deque>
#include <chrono>
#include <cassert>
#include <bitset>
#include <random>

using namespace std;

typedef long long li;
typedef  long double ld;
const li MAX = (li)2e6 + 100;

li inf = (li)1e18;
li mod = (li)1e13 + 2987429;
li n, q;
struct node{
    li l, r, mid, prog, ad;
    node* son_l;
    node* son_r;
    node(li a, li b){
        l = a;
        r = b;
        mid = (a + b) / 2;
        prog = 0;
        ad = 0;
    }
};

node* x;
node* y;

void build(node* root){
    if (root->l == root->r) return;
    else{
        root->son_l = new node (root->l, root->mid);
        root->son_r = new node (root->mid + 1, root->r);
        build(root->son_l);
        build(root->son_r);
    }
}

void push(node* root){
    root->son_l->ad += root->ad;
    root->son_r->ad += root->ad;
    root->son_l->prog += root->prog;
    root->son_r->prog += root->prog;
    root->ad = 0;
    root->prog = 0;
}

void ad_prog(node* root, li bl, li br, li val){
    if (bl > br) return;
    else if (root->l == bl && root->r == br) root->prog += val;
    else{
        push(root);
        ad_prog(root->son_l, bl, min(br, root->mid), val);
        ad_prog(root->son_r, max(root->mid + 1, bl), br, val);
    }
}

void pl(node* root, li bl, li br, li val){
    if (bl > br) return;
    else if (root->l == bl && root->r == br) root->ad += val;
    else{
        push(root);
        pl(root->son_l, bl, min(br, root->mid), val);
        pl(root->son_r, max(root->mid + 1, bl), br, val);
    }
}

li get_val(node* root, li ind){
    if (root->l == ind && root->r == ind){
        return root->ad + root->l * root->prog;
    }
    else{
        push(root);
        if (root->mid >= ind) return get_val(root->son_l, ind);
        else return get_val(root->son_r, ind);
    }
}

void solve(){
    cin >> n >> q;
    x = new node(1, n);
    y = new node(1, n);
    build(x);
    build(y);
    for (int i = 1; i <= n; i++){
        pl(x, i, i, i);
    }

    for (int i = 1; i <= q; i++){
        li t;
        cin >> t;
        if (t == 1){
            li l, r;
            cin >> l >> r;
            if (get_val(y, l) == get_val(y, r)){
                ad_prog(x, l + 1, r, -1);
                pl(x, l + 1, r, l);
                ad_prog(y, l + 1, r, 1);
                pl(y, l + 1, r, -l);
            }
            else{
                ad_prog(x, l + 1, r, 1);
                pl(x, l + 1, r, -l);
                ad_prog(y, l + 1, r, -1);
                pl(y, l + 1, r, l);
            }
        }
        else{
            li v;
            cin >> v;
            cout << get_val(x, v) << " " << get_val(y, v) << "\n";
        }
    }

}
int main() {
    mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
    li q;
    ios::sync_with_stdio(0);
    q = 1;
    while (q--) solve();

    return 0;
}
