#include <iostream>
#include <algorithm>
#include <iomanip>
using namespace std;
#define int long long

const int MAX_N = 3e5;
double masses[MAX_N];
double cur_time = 0;
int n;
double v, u;

double get_mass(int i) {
    return masses[i] - cur_time * v;
}

void set_mass(int i, double new_val) {
    double cur_val = get_mass(i);
    masses[i] += (new_val - cur_val);
}

signed main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> v >> u;
    for(int i = 0; i < n; i++)
        cin >> masses[i];
    sort(masses, masses + n, greater<int>());
    int max_cnt = 1;

    while (max_cnt < n) {
        double cur_val = get_mass(0);
        double next = get_mass(max_cnt);
        /// cur_val - t * (v + u / cnt) = next - t * v
        /// cur_val - next = t * (u/cnt)
        double t = (cur_val - next) / (u / max_cnt);
        double result_value = cur_val - (v + u/max_cnt) * t;

        if (result_value >= 0) {
            //cout << "t: " << t << endl;
            cur_time += t;
            set_mass(0, result_value);
            max_cnt++;
        }
        else {
            //cout << "oof. t was " << t << endl;
            cur_time += (0 - cur_val) / (result_value - cur_val) * t;
            goto print_ans;
        }
    }
    //cout << "in the end: cur_time, max_cnt, get_mass(0):" << cur_time << ' ' << max_cnt << " " << get_mass(0) << endl;
    //cout << "shit: " << (v + u / max_cnt)
    cur_time += get_mass(0) / (v + u / max_cnt);

    print_ans:
    //cout << "time: " << cur_time << endl;
    cout << fixed << setprecision(10) << u * cur_time;
    return 0;
}
