#include <unordered_map>
#include <functional>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <numeric>
#include <sstream>
#include <utility>
#include <string>
#include <vector>
#include <cstdio>
#include <bitset>
#include <random>
#include <cmath>
#include <queue>
#include <stack>
#include <ctime>
#include <map>
#include <set>


#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")

#define all(x) (x).begin(), (x).end()
#define an cerr << "---"; cerr.flush()

using namespace std;

typedef long long ll;
typedef double ld;

const ll inf = (ll)1e18 + 228;
const ll cst = (ll)2e5 + 5;
const ll mod = (ll)1e9 + 7;

void operator delete(void*);

void ex(ll exitCode = 0) {
#ifdef _DEBUG
    //system("pause");
#endif // _DEBUG
    exit(exitCode);
}

ll n;

vector<string> vc;

ll dist(const string& a, const string& b) {
    vector<vector<ll>> dp(a.size() + 1, vector<ll>(b.size() + 1, inf));
    dp[0][0] = 0;
    for (ll i = 1; i <= a.size(); i++) {
        for (ll j = 1; j <= b.size(); j++) {
            if (a[i - 1] == b[j - 1]) dp[i][j] = dp[i - 1][j - 1];
            dp[i][j] = min(dp[i][j], dp[i - 1][j] + 1);
            dp[i][j] = min(dp[i][j], dp[i - 1][j - 1] + 1);
            dp[i][j] = min(dp[i][j], dp[i][j - 1] + 1);
        }
    }
    return dp[a.size()][b.size()];
}

string s;

ll matrix[1010][1010];
ll d[1010];
ll back[1010];

bitset<1010> used;

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> s;
    vc.push_back(s);
    cin >> s;
    vc.push_back(s);
    cin >> n;
    while (n--) {
        cin >> s;
        vc.push_back(s);
    }
    n = vc.size();
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++) {
            if (i == j) continue;
            matrix[i][j] = dist(vc[i], vc[j]) * (n + 10) - 1;
        }
    }
    for (ll i = 0; i < 1010; i++) {
        d[i] = inf;
        back[i] = -1;
    }
    d[0] = 0;
    while(1) {
        ll v = -1;
        for (ll i = 0; i < n; i++) {
            if (d[i] == inf) continue;
            if (used[i]) continue;
            if (v == -1 || d[i] < d[v]) v = i;
        }
        if (v == -1) break;
        used[v] = 1;
        for (ll u = 0; u < n; u++) {
            if (d[u] > d[v] + matrix[v][u]) {
                d[u] = d[v] + matrix[v][u];
                back[u] = v;
            }
        }
    }
    cout << (d[1]) / (n + 10) + 1 << " " << ((d[1]) / (n + 10) + 1) * (n + 10) - d[1] - 1 << endl;
    ll curr = 1;
    vector<ll> ans;
    while (curr > -1) {
        ans.push_back(curr);
        curr = back[curr];
    }
    reverse(all(ans));
    for (ll i = 1; i < ans.size() - 1; i++) cout << vc[ans[i]] << endl;
    return 0;
}
