#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <set>
#include <bitset>
#include <cmath>
using namespace std;

typedef long long ll;

struct Point {
	int x, y;
	Point() {

	}
	Point(int _x, int _y) {
		x = _x;
		y = _y;
	}
};

Point operator-(Point a, Point b) {
	return Point(a.x - b.x, a.y - b.y);
}

bool operator < (Point a, Point b) {
	return make_pair(a.x, a.y) < make_pair(b.x, b.y);
}
bool operator == (Point a, Point b) {
	return make_pair(a.x, a.y) == make_pair(b.x, b.y);
}

double Q(double x) {
	return x * x;
}

double dist(double x1, double y1, double x2, double y2) {
	return sqrt(Q(x1 - x2) + Q(y1 - y2));
}

ll cross_product(Point a, Point b) {
	return (ll)a.x * b.y - (ll)b.x * a.y;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, l;
	cin >> n >> l;
	vector<Point>pnt;
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		pnt.emplace_back(x - l, y);
		pnt.emplace_back(x, y - l);
		pnt.emplace_back(x, y + l);
		pnt.emplace_back(x + l, y);
	}
	sort(pnt.begin(), pnt.end());
	pnt.resize(unique(pnt.begin(), pnt.end()) - pnt.begin());
	int ind = min_element(pnt.begin(), pnt.end()) - pnt.begin();
	Point ld = pnt[ind];
	pnt.erase(pnt.begin() + ind);
	sort(pnt.begin(), pnt.end(), [&](Point a, Point b) {
		double al1 = atan2(a.y - ld.y, a.x - ld.x);
		double al2 = atan2(b.y - ld.y, b.x - ld.x);
		double d1 = dist(a.x, a.y, ld.x, ld.y);
		double d2 = dist(b.x, b.y, ld.x, ld.y);
		return make_pair(al1, d1) < make_pair(al2, d2);
	});
	
	vector<Point> st = { ld };
	pnt.push_back(ld);
	for (int i = 0; i < pnt.size(); i++) {
		while (st.size() >= 2 && cross_product(st[st.size() - 1] - st[st.size() - 2], pnt[i] - st[st.size() - 1]) < 0) {
			st.pop_back();
		}
		st.push_back(pnt[i]);
	}
	double res = 0;
	for (int i = 0; i < st.size() - 1; i++) {
		res += dist(st[i].x, st[i].y, st[i + 1].x, st[i + 1].y);
	}
	cout << fixed << setprecision(10)<<res;
	return 0;
}