#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;

const int N = 100100;
vector<int>g[N];
vector<pair<int, int>> edg;
bool used[N];

vector<int>c;
int col[N];
set<pair<int, int>> es;

void dfs(int v, int p) {
	used[v] = true;
	for (int u : g[v]) {
		if (u == p) {
			continue;
		}
		if (used[u] && !es.count({ v, u }) && !es.count({ u, v })) {
			edg.emplace_back(col[v], c.size());
			c.push_back(u);
			es.insert({ v, u });
		}
		if(!used[u]) {
			col[u] = c.size();
			c.push_back(u);
			edg.emplace_back(col[v], col[u]);
			es.insert({ v, u });
			dfs(u, v);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	col[1] = c.size();
	c.push_back(1);
	dfs(1, -1);
	cout << c.size() << "\n";
	for (int i = 0; i < c.size(); i++) {
		cout << c[i] << " ";
	}
	cout << "\n";
	for (auto x : edg) {
		cout << x.first + 1 << " " << x.second + 1 << "\n";
	}

}