#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <climits>
#include <map>
#include <iomanip>
#include <queue>
#include <random>
#include <ctime>

using namespace std;

#pragma warning (disable: 4996)

vector<long long> g[(long long)1e5 + 100];

void bfs(long long beg, vector<long long>& d)
{
	queue<long long> q;
	q.push(beg);
	d[beg] = 0;
	while (q.size() > 0)
	{
		long long pos = q.front();
		q.pop();
		if (d[pos] > 3)
			break;
		for (long long to : g[pos])
		{
			if (d[to] > d[pos] + 1)
				d[to] = d[pos] + 1, q.push(to);
		}
	}
}

void dfs(long long pos, vector<long long>& dist, long long& sum, long long prev = -1, long long d = 0)
{
	if (d == 2)
	{
		for (long long to : g[pos])
			if (to != prev && dist[to] == 1)
				sum++;
		return;
	}
	for (long long to : g[pos])
		if (to != prev)
			dfs(to, dist, sum, pos, d + 1);
}

int main() 
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	
	long long n, m;
	cin >> n >> m;
	for (long long i = 0; i < m; i++)
	{
		long long v1, v2;
		cin >> v1 >> v2;
		g[v1].push_back(v2);
		g[v2].push_back(v1);
	}

	vector<long long> d(n + 1, 1e9);
	bfs(1, d);
	long long ans = 0;
	dfs(1, d, ans);
	cout << ans;
}