#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;

template<typename T1, typename T2>
bool chkmax(T1 &a, T2 b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chkmin(T1 &a, T2 b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

int max(int a, int b) { return a > b ? a : b; }

ld sqr(ld a) { return a * a; }

const int INF = 1e18;

#define endl "\n"
#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

struct pt {
    int x, y;
    pt(): x(0), y(0) {}
    pt(int x, int y): x(x), y(y) {}
    pt(pt a, pt b): x(b.x - a.x), y(b.y - a.y) {}
    pt operator -(pt ot) {
        return pt(x - ot.x, y - ot.y);
    }

    int operator*(pt ot) {
        return x * ot.y - y * ot.x;
    }
    int operator%(pt ot) {
        return x * ot.x + y * ot.y;
    }

    friend int dist(pt a, pt b) {
        return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
    }
};

void solve() {
    int n, l;
    cin >> n >> l;
    vector <pt> a; // thanks to Mike Mirzayanov
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a.emplace_back(x - l, y);
        a.emplace_back(x + l, y);
        a.emplace_back(x, y - l);
        a.emplace_back(x, y + l);
    }
    pt fi = a[0];
    for (int i = 0; i < a.size(); ++i) {
        if (a[i].x < fi.x || (a[i].x == fi.x && a[i].y < fi.y)) {
            fi = a[i];
        }
    }
    sort(a.begin(), a.end(), [&](pt i, pt j) {
       return pt(fi, i) * pt(fi, j) > 0 || (pt(fi, i) * pt(fi, j) == 0 && dist(fi, i) <= dist(fi, j));
    });
    vector <pt> st;
    for (int i = 0; i < a.size(); ++i) {
        while (st.size() >= 2 && pt(st[st.size() - 2], st[st.size() - 1]) * pt(st[st.size() - 1], a[i]) <= 0) {
            st.pop_back();
        }
        st.push_back(a[i]);
    }
//    for (pt i : st) {
//        cout << i.x << " " << i.y << "\n";
//    }
    double per = 0;
    for (int i = 0; i < st.size(); ++i) {
        per += sqrt(dist(st[i], st[(i + 1) % st.size()]));
    }
    cout << setprecision(228) << fixed << per << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}