#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;
template <typename T1, typename T2>
bool chkmax(T1& a, T2 b) { if (b > a) { a = b; return true; } return false; }
template <typename T1, typename T2>
bool chkmin(T1& a, T2 b) { if (b < a) { a = b; return true; } return false; }
int max(int a, int b) { return a > b ? a : b; }
ld sqr(ld a) { return a * a; }
const int INF = 1e18;

#define endl "\n"
#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

void solve() {
    int n;
    cin >> n;
    vector <int> dv;
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            dv.push_back(i);
            if (i * i != n) {
                dv.push_back(n / i);
            }
        }
    }
    int ans = 1e10;
    for (int a : dv) {
        chkmin(ans, abs(a - n / a));
    }
    const int to = 1e7 / 5;
    for (int cnt1 = 0; cnt1 < to && cnt1 < n; ++cnt1) {
        for (int cnt2 : {cnt1 - 1, cnt1, cnt1 + 1}) {
            if (cnt2 >= 1 && cnt1 + cnt2 <= n) {
                int b = (n + cnt1) / (cnt1 + cnt2);
                if (b == 0) {
                    continue;
                }
                if (cnt1 * (b - 1) + cnt2 * b == n) {
                    chkmin(ans, abs(b - cnt1 - cnt2));
                }
            }
        }
    }
    for (int b = 1; b < to; ++b) {
        for (int cnt1 : {(n - 1) / (2 * b - 1), n / (2 * b - 1), (n + b) / (2 * b - 1)}) {
            int cnt2 = (n - cnt1 * (b - 1)) / b;
            if (cnt2 >= 1 && cnt1 + cnt2 <= n && cnt1 >= 0 && cnt1 < n) {
                if (cnt1 * (b - 1) + cnt2 * b == n) {
                    chkmin(ans, abs(b - cnt1 - cnt2));
                }
            }
        }
    }
    cout << ans << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}