#define _CRN_NO_SECURE_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstdio>
#include <vector>
#include <stack>
#include <set>
#include <map>

#define endl '\n'

using namespace std;

const int N = 5e5;
int n, m, v;
int used[N];
vector <int> color;
vector <set<int> > g;

void change(int pos, int to)
{
	v++;
	g[pos].erase(to);
	g[to].erase(pos);
	g[v].insert(to);
	g[to].insert(v);
	color.push_back(pos);
}

void dfs(int pos, int pred)
{
	used[pos] = true;
	for (int to : g[pos])
	{
		if (used[to] && pred != to)
		{
			change(pos, to);
			break;
		}
		if (!used[to])
		{
			dfs(to, pos);
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif
	cin >> n >> m;
	for (int i = 0; i < n; i++)
		color.push_back(i + 1);
	v = n;
	g.resize(N);
	for (int i = 0; i < m; i++)
	{
		int x, y;
		cin >> x >> y;
		g[x].insert(y);
		g[y].insert(x);
	}

	for (int i = 1; i <= n; i++)
		if (!used[i])
			dfs(i, g[i].begin());

	cout << color.size() << endl;
	for (int i : color)
		cout << i << ' ';
	cout << endl;
	for (int i = 0; i < g.size(); i++)
		for (auto j : g[i])
			g[j].erase(i), cout << i << ' ' << j << endl;
}