#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <math.h>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <cmath>

using namespace std;

#define ll long long
#define endl '\n'
#define BE(v) v.begin(), v.end()

const int N = 1e6;
const int R = (1 << 18);

pair<int, int> operator+=(pair<int, int>& a, pair<int, int> b)
{
    a = make_pair(a.first + b.first, a.second + b.second);
    return a;
}

pair<int, int> operator-(pair<int, int> a, pair<int, int> b)
{
    return { a.first - b.first,a.second - b.second };
}

pair<int, int> operator+(pair<int, int> a, pair<int, int> b)
{
    return { a.first + b.first,a.second + b.second };
}

struct Node
{
    pair<int, int> sum;
    bool rev;
};

Node v[N];

void push(int ind)
{
    if (v[ind].rev)
    {
        swap(v[ind].sum.first, v[ind].sum.second);
        v[ind * 2].rev ^= 1;
        v[ind * 2 + 1].rev ^= 1;
    }
    v[ind].rev = 0;
}

void rev(int ind, int L, int R, int l, int r)
{
    push(ind);
    if (l <= L && R <= r)
    {
        v[ind].rev ^= 1;
        push(ind);
        return;
    }
    if (l >= R || r <= L)
    {
        return;
    }
    push(ind);
    rev(ind * 2, L, (L + R) / 2, l, r);
    rev(ind * 2 + 1, (L + R) / 2, R, l, r);
    v[ind].sum = v[2 * ind].sum + v[2 * ind + 1].sum;
}

pair<int, int> sum(int ind, int L, int R, int r, int l = 1)
{
    push(ind);
    if (l <= L && R <= r)
    {
        return v[ind].sum;
    }
    if (l >= R || r <= L)
    {
        return { 0,0 };
    }
    pair<int, int> now = { 0,0 };
    now += sum(ind * 2, L, (L + R) / 2, r);
    now += sum(ind * 2 + 1, (L + R) / 2, R, r);
    return now;
}

void upd(int i)
{
    if (i > 0)
    {
        push(i);
        v[i].sum = v[2 * i].sum + v[2 * i + 1].sum;
        upd(i / 2);
    }
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++)
    {
        v[R + i].sum = { 1,0 };
    }
    for (int i = R - 1; i > 0; i--)
    {
        v[i].sum = v[2 * i].sum + v[2 * i + 1].sum;
    }
    for (int i = 0; i < q; i++)
    {
        int ind;
        cin >> ind;
        if (ind == 1)
        {
            int l, r;
            cin >> l >> r;
            pair<int, int> now = sum(1, 1, R + 1, r + 1);
            rev(1, 1, R + 1, l, r);
            pair<int, int> nnow = sum(1, 1, R + 1, r);
            v[R + r - 1].sum = now - nnow;
            upd((R + r - 1) / 2);
        }
        /*for (int j = 1; j <= n; j++)
        {
            auto now = sum(1, 1, R + 1, j);
            cout << now.first + 1 << " " << now.second << endl;
        }*/
        if (ind == 2)
        {
            int j;
            cin >> j;
            auto now = sum(1, 1, R + 1, j);
            cout << now.first + 1 << " " << now.second << endl;
        }
    }
}
