#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <iomanip>
using namespace std;

#define once solve();
#define multiple int t; read(t); for (int i = 0; i < t; i++) {solve();}

#ifdef LOCALRUN
#define watch(a) cout << "> " << (#a) << " = " << (a) << nl;
#endif

#ifndef LOCALRUN
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#define watch(a)
#endif

constexpr char nl = '\n';

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using intp = pair<int, int>;
using intpp = pair<int, pair<int, int>>;
using llp = pair<ll, ll>;
using llpp = pair<ll, pair<ll, ll>>;

inline void prepare() {
#ifdef LOCALRUN
    freopen("C++/input.txt", "r", stdin);
    freopen("C++/output.txt", "w", stdout);
#endif
    
#ifndef LOCALRUN
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
}

vector<int> vec[100000], vec2[200000];
bool used[100000];
int ans[200000];
int revAns[200000];
int ansPos = 0;
set<pair<int, int>> ss;

inline void dfs(int now) {
    for (int i: vec[now]) {
        if (ss.find({now, i}) == ss.end() && ss.find({i, now}) == ss.end()) {
            ss.insert({i, now});
            if (used[i]) {
                ans[ansPos] = i;
                vec2[revAns[now]].push_back(ansPos);
                vec2[ansPos].push_back(revAns[now]);
                revAns[i] = ansPos;
                ansPos++;
            } else {
                used[i] = true;
                vec2[revAns[now]].push_back(ansPos);
                vec2[ansPos].push_back(revAns[now]);
                ans[ansPos] = i;
                revAns[i] = ansPos;
                ansPos++;
                dfs(i);
            }
        }
    }
}

inline void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        vec[a].push_back(b);
        vec[b].push_back(a);
    }

    used[0] = true;
    ans[ansPos++] = 0;
    revAns[0] = 0;
    for (int i: vec[0]) {
        vec2[ansPos].push_back(0);
        vec2[0].push_back(ansPos);
        used[i] = true;
        ans[ansPos] = i;
        revAns[i] = ansPos;
        ansPos++;
        ss.insert({i, 0});
    }

    for (int i: vec[0]) {
        dfs(i);
    }

    cout << ansPos << nl;

    for (int i = 0; i < ansPos; i++) {
        cout << ans[i] + 1 << ' ';
    }
    cout << nl;

    for (int i = 0; i < ansPos; i++) {
        for (int j: vec2[i]) {
            if (i < j) {
                cout << i + 1 << ' ' << j + 1 << nl;
            }
        }
    }
}

int main()
{
    prepare();
    once
    return 0;
}
