#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <iomanip>
using namespace std;

#define once solve();
#define multiple int t; read(t); for (int i = 0; i < t; i++) {solve();}

#ifdef LOCALRUN
#define watch(a) cout << "> " << (#a) << " = " << (a) << nl;
#endif

#ifndef LOCALRUN
#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#define watch(a)
#endif

constexpr char nl = '\n';

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using intp = pair<int, int>;
using intpp = pair<int, pair<int, int>>;
using llp = pair<ll, ll>;
using llpp = pair<ll, pair<ll, ll>>;

inline void prepare() {
	// #ifdef LOCALRUN
	// freopen("C++/input.txt", "r", stdin);
	// freopen("C++/output.txt", "w", stdout);
	// #endif

#ifndef LOCALRUN
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
#endif
}

vector<int> paths[100001];
bool need[100001];
ll ans = 0;

void dfs(int now, int v, int prev) {
	if (now == 3) {
		if (need[v]) {
			++ans;
		}
		return;
	}
	for (int i : paths[v]) {
		if (i != prev) {
			dfs(now + 1, i, v);
		}
	}
	return;
}

inline void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		paths[v].push_back(u);
		paths[u].push_back(v);
		if (v == 1) {
			need[u] = true;
		}
		else if (u == 1) {
			need[v] = true;
		}
	}
	dfs(0, 1, -1);
	cout << ans;
}

int main()
{
	prepare();
	once
		return 0;
}