#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")

#define _USE_MATH_DEFINES
#include<iostream>
#include<algorithm>
#include<tuple>
#include<vector>
#include<deque>
#include<queue>
#include<stack>
#include<string>
#include<map>
#include<unordered_map>
#include<set>
#include<unordered_set>
#include<iomanip>
#include<math.h>
#include<functional>
#include<list>
#include<bitset>

using namespace std;


vector<int> used;
vector<vector<int>> g;
vector<int> colors;
vector<pair<int, int>> edges;
int n;
int current_num = 1;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> n >> m;
    g.resize(n);
    edges.reserve(m);
    colors.reserve(m + 1);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    used.resize(n);
    for (int i = 0; i < n; ++i)
        used[i] = g[i].size();
    queue<int> q;
    q.push(0);
    colors.push_back(1);
    vector<int> nums_for_v(n, 0);
    nums_for_v[0] = current_num;
    while (!q.empty()) {
        int cur = q.front();
        q.pop();
        for (int v : g[cur]) {
            if (used[v] > 0) {
                q.push(v);
                colors.push_back(v + 1);
                ++current_num;
                nums_for_v[v] = current_num;
                edges.push_back({ nums_for_v[cur], current_num });
                used[v] -= 1;
                used[cur] -= 1;
            }
        }
    }
    cout << colors.size() << '\n';
    for (auto i : colors)
        cout << i << ' ';
    cout << '\n';
    for (auto e : edges)
        cout << e.first << ' ' << e.second << '\n';
}