#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <climits>
#include <queue>
#include <string>
using namespace std;
typedef long long ll;

const int INF = INT_MAX;

vector<int> graph[100000 + 2];
bool used[100000 + 2];

vector <int> color;
vector <pair< int, int>> edges2;

void dfs(int v, int pred, int k) {
    used[v] = true;
    for (auto u: graph[v]) {
        if (u == pred) {
            continue;
        }
        color.push_back(u);
        edges2.push_back({k, color.size()});
        if (!used[u]) {
            dfs(u, v, color.size());
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;b--;

        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    color.push_back(0);
    dfs(0, -1, 0);

    cout << color.size() << '\n';
    for (auto e: color) {
        cout << e + 1 << ' ';
    }
    cout << '\n';
    for (auto e: edges2) {
        cout << e.first + 1 << ' ' << e.second + 1 << '\n';
    }

    return 0;
}